REM IpToCountry.bas
    ' Copyright (c) 2018 - 2019 WiseBox.Solutions
    ' All rights reserved.
    ' KKelbert@Wisebox.Solutions; support@wisebox.solutions
    '
    
REM Compiler Directives
    #COMPILER PBWIN 10
    #COMPILE EXE "IpToCountry"
    #OPTION VERSION5
    #DIM ALL
    #DEBUG ERROR ON
    #REGISTER NONE
    #INCLUDE "win32api.inc"

REM CONSTS    
    $FileIn                 = "./IpToCountry.csv"
    $FileOut                = "./Ip2Country.tab"
    
REM Main
    FUNCTION PBMAIN () AS LONG
        Local lsHeader, lsData, lsaData(), lsTmp, lsaTmp() as string
        local llC1, llC2, llC3 as long
        
        lsHeader = "IpFrom" & $Tab & "IpTo" & $Tab & "Registry" & $Tab & "Assigned" & $Tab & "Ctry" & $Tab & "Cntry" & $Tab & "Country"
        
        sFileGet $FileIn, lsData, llC1
        If llC1 < 100 Then
            MsgBox "The " & $FileIn & " file is incorrect." & $CRLF & "Press Enter to exit."
            Exit Function
        End If
        
        lsData  =	Remain$( lsData, ("#" & $Lf & $DQ))
        lsData  =   Trim$( lsData, $LF)
        Replace $DQ + "," + $DQ With $TAB  IN lsData
        Replace $DQ             With ""    IN lsData
        Replace $LF             With $CRLF IN lsData
        
        sFilePut $FileOut, lsHeader & $CRLF & lsData
    END FUNCTION
    
REM SubRoutines
    
    SUB sFileGet( psCompletePath AS STRING, psData AS STRING, plLOF as long)
        LOCAL llFileNum as long
        llFileNum = FREEFILE
        psData = ""
        open psCompletePath for binary LOCK SHARED as llFileNum
            plLOF = LOF(llFileNum)
            get$ llFileNum, lof(llFileNum), psData
        close llFileNum
    end sub
    
    SUB sFilePut( psCompletePath AS STRING, psData AS STRING)
        LOCAL llFileNum as long
        llFileNum = FREEFILE
        open psCompletePath for binary LOCK SHARED as llFileNum
            put$ llFileNum, psData : seteof(llFileNum)
        close llFileNum
    END SUB
    
        