REM ' Cnawlece V3 Custom DLL Example - Custom.bas
    ' Copyright (c) 2009, Cnawlece Incorporated
    ' All rights reserved.
    '
    ' Redistribution and use in source and binary forms, with or without
    ' modification, are permitted provided that the following conditions are met:
    '     * Redistributions of source code must retain the above copyright
    '       notice, this list of conditions and the following disclaimer.
    '     * Redistributions in binary form must reproduce the above copyright
    '       notice, this list of conditions and the following disclaimer in the
    '       documentation and/or other materials provided with the distribution.
    '     * Neither the name of the Cnawlece nor the
    '       names of its contributors may be used to endorse or promote products
    '       derived from this software without specific prior written permission.
    '
    ' THIS SOFTWARE IS PROVIDED BY Cnawlece Incorporated ''AS IS'' AND ANY
    ' EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
    ' WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    ' DISCLAIMED. IN NO EVENT SHALL Cnawlece Incorporated BE LIABLE FOR ANY
    ' DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
    ' (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
    ' LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    ' ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    ' (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
    ' SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


REM Compiler Directives
    #COMPILER PBWIN 10
    #COMPILE DLL
    #OPTION LARGEMEM32
    #OPTION VERSION5
    #DIM ALL
    #DEBUG ERROR ON 'Better to be a touch slower than crash the server!
    #REGISTER NONE


REM COM Object Specs
    #COM NAME "Moxie_Custom", 3.00
    #COM GUID "Moxie___Cst03.00"
    #COM TLIB OFF

REM Build for Moxie version and date,
    'this must match the same version and
    'date as the Moxie Server being used.
    $BuiltFor = "4.00 20xx-xx-xx"

REM Windows API
    %USEMACROS = 1
    #INCLUDE "WIN32API.inc"

REM Base Moxie Equates, etc.
    #INCLUDE "Moxie.inc"
    #INCLUDE "Util.bas"

REM Custom Modules
    '#INCLUDE "Content.bas"
    '#INCLUDE "Admin.bas"


CLASS cCustom "Moxie____cC03.00"  AS COM
    'instance ioAdmin   as iAdmin
    'instance ioContent as iContent

    INTERFACE iCustom "Moxie____iC03.00"
        INHERIT DUAL

        METHOD Update <7711> (BYREF INOUT poDB AS iDatabase, BYREF INOUT poReq AS iRequest, BYREF INOUT poTmpl AS iTemplate, BYREF INOUT poQ AS iQuery) AS STRING
            REGISTER rlPrc AS LONG : rlPrc = CVDWD("CUpd")
            REGISTER rlBlk AS LONG : rlBlk = &hA0A0A0A0
            LOCAL llResult AS LONG
            LOCAL lsErr AS STRING

            SELECT CASE AS CONST$ LCASE$(EXTRACT$(poQ.Message, "."))
                'case "content"
                    'rlBlk = &hA1A0A0A0
                    'if isnothing(ioContent) then
                    '    ioContent = class "cContent"
                    '    if isnothing(ioContent) then method objresult = %E_FAIL : exit method
                    'end if
                    'lsErr = ioContent.Update(poQ, poDB)
                    'llResult = objresult

                'case "admin"
                    'rlBlk = &hA8A0A0A0
                    'if isnothing(ioAdmin) then
                    '    ioAdmin = class "cAdmin"
                    '    if isnothing(ioAdmin) then method objresult = %E_FAIL : exit method
                    'end if
                    'lsErr = ioAdmin.Update(poQ, poDB)
                    'llResult = objresult

            END SELECT

            METHOD = lsErr
            METHOD OBJRESULT = llResult
        END METHOD


        METHOD Request <7712> (BYREF INOUT poDB AS iDatabase, BYREF INOUT poReq AS iRequest, BYREF INOUT poTmpl AS iTemplate) AS STRING
            REGISTER rlPrc AS LONG : rlPrc = CVDWD("CReq")
            REGISTER rlBlk AS LONG : rlBlk = &hA0A0A0A0
            LOCAL llResult AS LONG
            LOCAL lsOut AS STRING

            SELECT CASE AS CONST$ LCASE$(EXTRACT$(poReq.Path, ANY ".\"))
                'case "admin"
                    'rlBlk = &hA8A0A0A0
                    'if isnothing(ioAdmin) then
                    '    ioAdmin = class "cAdmin"
                    '    if isnothing(ioAdmin) then method objresult = %E_FAIL : exit method
                    'end if
                    'lsOut = ioAdmin.Request(poReq, poDB, poEC)
                    'llResult = objresult

                'case else
                    'rlBlk = &hA1A0A0A0
                    'if isnothing(ioContent) then
                    '    ioContent = class "cContent"
                    '    if isnothing(ioContent) then method objresult = %E_FAIL : exit method
                    'end if
                    'lsOut = ioContent.Request(poReq, poDB, poEC)
                    'llResult = objresult

            END SELECT

            METHOD = lsOut
            METHOD OBJRESULT = llResult
        END METHOD


        PROPERTY GET CallList <7751> AS STRING
            'property =  "FirstLast (pFieldBase, pDestination, pFirstName, pLastName, pWorkIf)" + $R + _
            '            "LastFirst (pFieldBase, pDestination, pLastName, pFirstName, pWorkIf)"
        END PROPERTY


        METHOD CallProc <7755> (BYVAL IN psCall AS STRING, BYREF INOUT poDB AS iDatabase, BYREF INOUT poReq AS iRequest, BYREF INOUT poTmpl AS iTemplate, BYREF INOUT poParams AS iQuery, BYREF INOUT poWork AS iQuery) AS STRING
            'select case as const$ lcase$(psCall)
            '    case "firstlast"
            '        try
            '            poWork.EnsureFields(poParams.f("pFieldBase"), poParams.f("pDestination"))
            '            poWork.Build3(poParams.f("pFieldBase"), poParams.f("pDestination"), poParams.f("pFirstName"), " ", poParams.f("pLastName"), poParams.f("pWorkIf"))
            '        catch
            '            method = "Error building First and Last Names"
            '        end try
            '    case "lastfirst"
            '        try
            '            poWork.EnsureFields(poParams.f("pFieldBase"), poParams.f("pDestination"))
            '            poWork.Build3(poParams.f("pFieldBase"), poParams.f("pDestination"), poParams.f("pLastName"), ", ", poParams.f("pFirstName"), poParams.f("pWorkIf"))
            '        catch
            '            method = "Error building Last and First Names"
            '        end try
            'end select
        END METHOD


        PROPERTY GET BuiltFor <7791> AS STRING
            PROPERTY = $BuiltFor
        END PROPERTY

        METHOD System <7799> (BYVAL IN plMsg AS LONG, BYVAL IN plVal AS LONG, BYREF INOUT poDB AS iDatabase, BYREF INOUT poReq AS iRequest, BYREF INOUT poTmpl AS iTemplate, BYREF OUT plOut AS LONG) AS STRING
            REGISTER rlPrc AS LONG : rlPrc = CVDWD("CSys")
            REGISTER rlBlk AS LONG : rlBlk = &hA0A0A0A0
            LOCAL lsOut AS STRING

            rlBlk = &hA1A0A0A0
            SELECT CASE AS LONG plMsg
                CASE %CS_Notify
                    SELECT CASE AS LONG plVal
                        CASE %CS_Notify_Start_Begin
                        CASE %CS_Notify_Started_DB
                        CASE %CS_Notify_Started_TCP
                        CASE %CS_Notify_Start_End
                        CASE %CS_Notify_Stop_Begin
                        CASE %CS_Notify_Stopped_TCP
                        CASE %CS_Notify_Stopped_DB
                        CASE %CS_Notify_Stop_End
                    END SELECT
            END SELECT

            METHOD = lsOut
        END METHOD

    END INTERFACE
END CLASS
