REM PreProc.bas
    ' Copyright (c) 2018 - 2019 WiseBox.Solutions
    ' All rights reserved.
    ' KKelbert@Wisebox.Solutions; support@wisebox.solutions
    '
    
REM 'ToDo List
    ' Pedigree
    ' 2019-01-05 Make use of Moxie.cfg file's 'Meta = ' line to modify functioning of this code
    '   - multiple options per line
    '   - Meta = Nightly-Name1: Value1; Nightly-Name2: Value2
    ' 2018-07-14 per: https://trello.com/c/QYZSsd2y/14-ongoing-maintenance-of-preproc-nightly
    '	Nightly log-rotate to limit zip file size by breaking each zip file into many. All less than 700MB.
    ' 2017-04-07 [Slack:Iaas] Kerry - Could you, urgently, add a .zip backup of the Work folder to your nightly backup system?
    ' https://trello.com/c/l6R95UwP/25-s012-automation
    ' 2016-09-28 repair grabbing biz.session.cnd as well as session.cnd
    ' ToDo - Final zPreProc dated.zip file to be placed into same folder as PreProc.conf -> [BackupRootFolder] setting
    ' ToDo - Replace / ReImpliment any and all hard coded links to follow PreProc.conf convention
    ' Test - MoxView path to be found in PreProc.conf -> [MoxViewFolder] setting
    ' PostProc Stats, Exceptions & Logs
    ' 'Fast' search for Countries
    ' Impliment ServiceAudit logic from old MasterSwitch.bas.2014-04-10-0414
    ' Broken: Gather and PreProcess "Exception" file dates and flag them that fall between lsLastStatsSnapshot & StampItNowLogFmt for later processing
    '   Mode: 2014-07-02 Tosses the files that have GPF'd based on time stamp
    '   Require: a command that will cause a GPF (for testing)
    '   repaired 2014-07-04-0504
    ' Done - needs testing sat - Move reports to do move on sat AM run only - very long file names still error
    'next glFinalResult = 9
    
REM Compiler Directives
    #COMPILER PBWIN 10
    #COMPILE EXE "PreProc"
    #OPTION VERSION5
    #DIM ALL
    #DEBUG ERROR ON
    #TOOLS ON
    #OPTION LARGEMEM32
    #INCLUDE "win32api.inc"
    
REM 'Macros
    MACRO mCommitLog()
        If IsFalse( glLogQuiet) THEN CommitLog lsHomeFldr, lsResult
    END MACRO
    
    MACRO mABS_SRC          = lsaFolderPath(%FolderRoot, llFolderPathNum) + "\" + lsaFolderPath(%FolderObject, llFolderPathNum)
    MACRO mABS_DST          = lsaFolderPath(%BackupRoot, llFolderPathNum) + "\" + lsaFolderPath(%FolderObject, llFolderPathNum)
    
    MACRO mDEST_BIN         = mABS_DST + "\Bin"
    MACRO mDEST_LOG         = mABS_DST + "\Log"
    MACRO mDEST_DBSTORE     = mABS_DST + "\DBStore"
    MACRO mDEST_REPORTS     = mABS_DST + "\Reports"
    MACRO mDEST_WORK        = mABS_DST + "\Work"
    
    MACRO mSRC__2           = mABS_SRC + "\DBStore\*"
    MACRO mDEST_2           = mABS_DST + "\DBStore\" + StampItDateHM + ".zip"
    MACRO mSRC__3           = mABS_SRC + "\Private\*"
    MACRO mDEST_3           = mABS_DST + "\Private.zip"
    MACRO mSRC__4           = mABS_SRC + "\Public\*"
    MACRO mDEST_4           = mABS_DST + "\Public.zip"
    MACRO mSRC__5           = mABS_SRC + "\Templates\*"
    MACRO mDEST_5           = mABS_DST + "\Templates.zip"
    MACRO mSRC__6           = mABS_SRC + "\Work\*"
    MACRO mDEST_6           = mABS_DST + "\Work\" + StampItDateHM + ".zip"
    
REM 'Consts
    $ProgramName            = "PreProc"
    $PreProcTempFile        = "PreProc.Ok2del"
    $PreProcListFile        = "PreProc.Include"
    $PreProcCfgName         = "PreProc.conf"
    
    $SEP_NUL                = CHR$(0)
    $SEP_SOH                = CHR$(1)
    $SEP_CRLF               = "<cnw-$crlf>"
    $SEP_CR                 = "<cnw-$cr>"
    $SEP_LF                 = "<cnw-$lf>"
    $SEP_TAB                = "<cnw-$tab>"
    
    $FlagIfNotEmpty         = "$FlagIfNotEmpty"
    $FlagIfEmpty            = "$FlagIfEmpty"
    $FlagIfNotIncludes      = "$FlagIfNotIncludes"
    $FlagIfIncludes         = "$FlagIfIncludes"
    $Ignore                 = "$Ignore"
    
    %dir_DBStore            = &h0001
    %dir_History            = &h0002
    %dir_Lib                = &h0004
    %dir_Private            = &h0008
    %dir_Public             = &h0010
    %dir_Recv               = &h0020
    %dir_Templates          = &h0040
    %dir_Work               = &h0080
    
    %file_Replace           = 0
    %file_Append            = 1
    
    %statsAlias             = 1
    %statsStatTime          = 2     :  $statsStatTime       = "StatTime ="
    %statsMoxieVer          = 3     :  $statsMoxieVer       = "MoxieVer ="
    %statsHttpState         = 4     :  $statsHttpState      = "HttpState ="
    %statsHttpsState        = 5     :  $statsHttpsState     = "HttpsState ="
    %statsBkRecvState       = 6     :  $statsBkRecvState    = "BkRecvState ="
    %statsSrvHits           = 7     :  $statsSrvHits        = "SrvHits ="
    %statsSrvCurrent        = 8     :  $statsSrvCurrent     = "SrvCurrent ="
    %statsSrvPeek           = 9     :  $statsSrvPeek        = "SrvPeek ="
    %statsSrvCompleted      = 10    :  $statsSrvCompleted   = "SrvCompleted ="
    %statsSrvUnique         = 11    :  $statsSrvUnique      = "SrvUnique ="
    %statsSrvUniquePeek     = 12    :  $statsSrvUniquePeek  = "SrvUniquePeek ="
    %statsClientRead        = 13    :  $statsClientRead     = "ClientRead ="
    %statsClientWrite       = 14    :  $statsClientWrite    = "ClientWrite ="
    %statsBackupRead        = 15    :  $statsBackupRead     = "BackupRead ="
    %statsBackupWrite       = 16    :  $statsBackupWrite   	= "BackupWrite ="
    %MAXstatsFIELDS         = 16
    
    %FolderRoot             = 1
    %BackupRoot             = 2
    %StatsRecv              = 3 
    %FolderObject           = 4 
    %ConfigData             = 5 
    %IP                     = 6     :   $cfgIP              = "IP ="            
    %MaxConnections         = 7     :   $cfgMaxConnections  = "MaxConnections ="
    %HttpPort               = 8     :   $cfgHttpPort        = "HttpPort ="      
    %HttpsPort              = 9     :   $cfgHttpsPort       = "HttpsPort ="     
    %CertFile               = 10    :   $cfgCertFile        = "CertFile ="      
    %RelayHttpsHost         = 11    :   $cfgRelayHttpsHost  = "RelayHttpsHost ="
    %Encoding               = 12    :   $cfgEncoding        = "Encoding ="      
    %RAMRecvSize            = 13    :   $cfgRAMRecvSize     = "RAMRecvSize ="   
    %DLLs                   = 14    :   $cfgDLLs            = "DLLs ="          
    %LocalBKPath            = 15    :   $cfgLocalBKPath     = "LocalBKPath ="   
    %SendBKName             = 16    :   $cfgSendBKName      = "SendBKName ="    
    %SendBKPort             = 17    :   $cfgSendBKPort      = "SendBKPort ="    
    %SendBKPWHash           = 18    :   $cfgSendBKPWHash    = "SendBKPWHash ="  
    %RecvBKPort             = 19    :   $cfgRecvBKPort      = "RecvBKPort ="    
    %RecvBKPWHash           = 20    :   $cfgRecvBKPWHash    = "RecvBKPWHash ="  
    %ServiceName            = 21    :   $cfgServiceName     = "ServiceName ="   
    %ServiceUser            = 22    :   $cfgServiceUser     = "ServiceUser ="   
    %DiskFlushTimer         = 23    :   $cfgDiskFlushTimer  = "DiskFlushTimer ="
    %AltIPInfo              = 24    :   $cfgAltIPInfo       = "AltIPInfo ="     
    %RelayNoAltIP           = 26    :   $cfgRelayNoAltIP    = "RelayNoAltIP ="  
    %ForcedCookies          = 27    :   $cfgForcedCookies   = "ForcedCookies =" 
    %Meta                   = 28    :   $cfgMeta            = "Meta ="          
    %MAXcfgFIELDS           = 28
    
                                    :   %F00eAlias          = 1
    %F01_FolderName         = 1     :   %F01eFolderName     = 2
    %F02_LogLocation        = 2     :   %F02eLogLocation    = 3
    %F03_TimeStamp          = 3     :   %F03eTimeStamp      = 4
    %F04_Thread             = 4     :   %F04eThread         = 5
    %F05_Category           = 5     :   %F05eCategory       = 6
    %F06_Message            = 6     :   %F06eMessage        = 7
    %F07_Details            = 7     :   %F07eDetails        = 8
    %F08_Bytes              = 8     :   %F08eBytes          = 9
    %F09_IPNum              = 9     :   %F09eIPNum          = 10
    %F10_ThreadNum          = 10    :   %F10eThreadNum      = 11
    %F11_ThreadTime         = 11    :   %F11eThreadTime     = 12
    %F12_PersonUUID         = 12    :   %F12ePersonUUID     = 13
    %F13_SessionUUID        = 13    :   %F13eSessionUUID    = 14
    %F14_Datum1             = 14    :   %F14eDatum1         = 15
    %F15_Datum2             = 15    :   %F15eDatum2         = 16
    %F16_Datum3             = 16    :   %F16eDatum3         = 17
    %F17_Datum4             = 17    :   %F17eDatum4         = 18
    %F18_MessageCode        = 18    :   %F18eMessageCode    = 19
    %F19_MoxVerMajor        = 19    :   %F19eMoxVerMajor    = 20
    %F20_MoxVerMinor        = 20    :   %F20eMoxVerMinor    = 21
    %F21_Country            = 21    :   %F21eCountry        = 22
    
    %Tdata                  = 21    :   %Tedata             = 22
    
Rem 'Main
    FUNCTION PBMAIN () AS LONG
        GLOBAL glFinalResult, glLogStats, glLogRotate, glLogQuiet, glAllOff, glAllOn, llIsCritical  AS LONG
        global gsFinalMessage as string
        local  lsCommand, lsHomeFldr, lsResult, lsWork, lsHeader, lsFooter, lsTmpLog, lsaFolderPath(), lsaMeta(), lsFile, lsaFiles(), lsaFiles1(), lsaFiles2(), lsTmp, lsaTmp(), lsaSrt(), lsData, lsaData() as string
        local  lsDest, lsaDest(), lsLastStatsSnapshot, lsNowStatsSnapshot, lsLookFor, lsPreProcEmail, lsBackupRootFolder, lsStatsRecvFolder, lsMoxViewFolder, lsMailServer, lsMailServerPort, lsMailFrom AS STRING
        local  lsEmailSubject, lsEmailOnError, lsEmailNoError, lsMoxieOnError, lsOrigFldr, lsWorkFldr, lsT1, lsT2, lsForceCnwEmailErr, lsServiceData, lsServiceName AS STRING
        local  llC1, llC2, llC21, llC22, llC3, llC4, llFlag, llFlag1, llFlag2, llLen, llBrokenFlag, llPerformZip, llFolderPathNum, llLOF as long
        LOCAL  lnTimer AS SINGLE
        LOCAL  tddDirData AS DIRDATA
        LOCAL  tiPowerTime AS IPOWERTIME
        
        REDIM                                               lsaFolderPath(0), lsaMeta(0), lsaFiles(0), lsaFiles1(0), lsaFiles2(0), lsaTmp(0), lsaData(0), lsaDest(0)
        
        lnTimer                                         =   TIMER
        glFinalResult                                   =   0
        StampItInit
        
        REM 'Preload the email notification with the command line settings
            gsFinalMessage                              +=  $CRLF + "Command-line arguments used to start the program: " + $CRLF + $TAB + command$
            
        REM 'Check command line parameters. manually verify with:
            '   c:\Util\PreProc>%comspec% /z /c PreProc /Logrotate /Stats /Quiet
            '   c:\Util\PreProc>%comspec% /z /c PreProc /AllOff
            '   c:\Util\PreProc>%comspec% /z /c PreProc /AllOn
            '   c:\Util\PreProc>echo %errorlevel%
            
            lsCommand                                   =   lcase$(trim$(command$))
            If isTrue( INSTR(lsCommand, "/quiet"))          THEN glLogQuiet    = %True
            If isTrue( INSTR(lsCommand, "/stats"))          THEN glLogStats    = %True
            If isTrue( INSTR(lsCommand, "/logrotate"))      THEN glLogRotate   = %True
            If isTrue( INSTR(lsCommand, "/alloff"))         THEN glAllOff      = %True
            If isTrue( INSTR(lsCommand, "/allon"))          THEN glAllOn       = %True
            
            If isfalse( glLogStats) _
            and isfalse(glLogRotate) _
            and isfalse(glAllOff) _
            and isfalse(glAllOn) _
            Then
                'NOTE: bacause sCaptureConfiguration has not been called yet, no email will be sent
                glFinalResult                           =   1
                GoTo                                        PrematureExit
            End If
            
        REM 'Find out where we are starting from
            lsCommand                                   =   "echo %cd%"
            ShellExec                                       "", "", lsCommand, lsHomeFldr
            lsHomeFldr                                  =   RTRIM$( lsHomeFldr, ANY " \") + "\"
            
        REM 'Remove any old tmp files from last run (the Moxie program run should have completed at this point!)
            if glLogRotate OR glLogStats Then
                lsCommand                               =   "DEL /Q /F /S " + $DQ + ".\Moxie\Recv\*.*" + $DQ
                ResultFlagOnShellExec                       "ShellExec", "", "", lsCommand, lsResult, $Ignore, ""
                mCommitLog
            END IF
            
        REM 'Capture all the config info
            sCaptureConfiguration                           lsHomeFldr, _
                                                            lsaFolderPath(), _
                                                            lsBackupRootFolder, _
                                                            lsStatsRecvFolder, _
                                                            lsMoxViewFolder, _
                                                            lsMailServer, _
                                                            lsMailServerPort, _
                                                            lsMailFrom, _
                                                            lsForceCnwEmailErr, _
                                                            lsEmailOnError, _
                                                            lsEmailNoError, _
                                                            lsMoxieOnError
            
            lsMoxViewFolder                             =   RTRIM$( lsMoxViewFolder, ANY " \") + "\"
            lsBackupRootFolder                          =   RTRIM$( lsBackupRootFolder, ANY " \") + "\"
            
            sCaptureConfigurationSave                       lsHomeFldr, _
                                                            lsaFolderPath(), _
                                                            lsResult
            mCommitLog
            
        REM	'Parse out the Meta info, per server
            MetaCapture lsaFolderPath(), lsaMeta()
            
        REM 'Ensure that our various programs are where they are supposed to be
            ' http://www.7-zip.org/faq.html
            ' 7-Zip stores only relative paths of files (without a drive letter prefix).
            ' To impliment, change the current folder to the folder that is common for all files that you want to compress and 
            ' then you can use relative paths
            
            lsCommand                                   =   "7za"
            IF ShellExec7za( lsHomeFldr + $ProgramName, lsHomeFldr, lsCommand, lsTmp) = %True _
            OR INSTR( lcase$( lsTmp), lcase$( "Copyright")) = %False _
            OR DIR$(lsHomeFldr + "PwrMail.exe") <> "PwrMail.exe" _
            OR DIR$(lsHomeFldr + "Moxie\Moxie.exe") <> "Moxie.exe" _
            OR DIR$(lsHomeFldr + "Moxie\Moxie.PreProc.mox") <> "Moxie.PreProc.mox" _
            OR DIR$(lsHomeFldr + "Moxie\Moxie.PreProc.SendGrid.mox") <> "Moxie.PreProc.SendGrid.mox" _
            Then
                lsTmp                                   =   "One or more of these programs is missing or not functioning:"
                lsTmp                                   +=  $CRLF + $TAB + "7za.exe"
                lsTmp                                   +=  $CRLF + $TAB + "PwrMail.exe"
                lsTmp                                   +=  $CRLF + $TAB + "Moxie\Moxie.exe"
                lsTmp                                   +=  $CRLF + $TAB + "Moxie\Moxie.PreProc.mox"
                lsTmp                                   +=  $CRLF + $TAB + "Moxie\Moxie.PreProc.SendGrid.mox"
                lsTmp                                   +=  $CRLF + "Cannot Proceed."
                lsResult                                +=  $CRLF + "Error: " + lsTmp
                gsFinalMessage                          +=  $Crlf + lsTmp
                glFinalResult                           =   3
                mCommitLog
                GoTo                                        PrematureExit
            Else
                lsResult                                +=  $CRLF + "Our zipping program (7za.exe) was found."
                mCommitLog
            End If
            
        REM 'If requested, handle MoxView service start/stop
            REM 'ServiceStop - lsMoxViewFolder
                if glAllOff Then
                    IF LEN( DIR$(lsMoxViewFolder + "Moxie.cfg")) THEN
                        sFileGet                            lsMoxViewFolder + "Moxie\Moxie.cfg", lsServiceData, llLen
                        IF LEN( lsServiceData) THEN
                            lsServiceName                =   TRIM$( EXTRACT$( REMAIN$( lsServiceData,$cfgServiceName     ), $CRLF))
                            lsCommand                    =   "NET STOP " + $DQ + lsServiceName + $DQ
                            llBrokenFlag                 =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotIncludes, "successfully")
                            mCommitLog
                        End If
                    END IF
                End If
                
            REM 'ServiceStart - lsMoxViewFolder
                if glAllOn Then
                    IF LEN( DIR$(lsMoxViewFolder + "Moxie.cfg")) THEN
                        sFileGet                            lsMoxViewFolder + "Moxie.cfg", lsServiceData, llLen
                        IF LEN( lsServiceData) THEN
                            lsServiceName                =   TRIM$( EXTRACT$( REMAIN$( lsServiceData,$cfgServiceName     ), $CRLF))
                            lsCommand                    =   "NET START " + $DQ + lsServiceName + $DQ
                            llBrokenFlag                 =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotIncludes, "successfully")
                            mCommitLog
                        End If
                    END IF
                End If
                
        REM 'Perform Moxie.PreProc.SendGrid.mox to PreProcess rejected emails
            IF LEN( DIR$(lsHomeFldr + "Moxie\Moxie.PreProc.SendGrid.mox")) THEN
                If glLogRotate THEN
                    lsCommand                           =   "CD /D " + $DQ + lsHomeFldr + "Moxie" + $DQ + " && Moxie.exe " + $DQ + "Moxie.PreProc.SendGrid.mox"
                    lsCommand                           +=  $DQ
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", lsWork, lsHomeFldr, lsCommand, lsResult, $Ignore, "")
                    mCommitLog
                END IF
            END IF
                
        FOR llFolderPathNum = 1 TO UBOUND( lsaFolderPath(2))
            
            lsWork                                      =   lsaFolderPath( %FolderRoot, llFolderPathNum) + "\" + lsaFolderPath( %FolderObject, llFolderPathNum) + "\"
            
            IF  ISTRUE(LEN( lsaFolderPath(%BackupRoot,      llFolderPathNum))) _
            AND ISTRUE(LEN( lsaFolderPath(%FolderRoot,      llFolderPathNum))) _
            AND ISTRUE(LEN( lsaFolderPath(%StatsRecv,       llFolderPathNum))) _
            AND ISTRUE(LEN( lsaFolderPath(%FolderObject,    llFolderPathNum))) _
            AND ISTRUE(LEN( lsaFolderPath(%ServiceName,     llFolderPathNum))) _
            AND ISTRUE(LEN( lsaFolderPath(%ServiceUser,     llFolderPathNum))) _
            THEN
                REM 'Folder Init
                    lsHeader                            =   "<" & $ProgramName & ".Folder " + lsaFolderPath(%FolderObject, llFolderPathNum) + ">"
                    lsFooter                            =   "</" & $ProgramName & ".Folder>"
                    lsResult                            +=  $CRLF + lsHeader
                
                REM 'Stats Init
                    If glLogStats then
                        sFileGet                            mABS_SRC + "\Moxie.stats.Last", lsData, llLen
                        lsLookFor                       =   "[StatsLast] = "
                        lsNowStatsSnapshot              =   StampItNowLogFmt
                        If INSTR( lsData, lsLookFor) THEN
                            lsLastStatsSnapshot         =   remain$( lsData, lsLookFor)
                            lsLastStatsSnapshot         =   TRIM$( Extract$( lsLastStatsSnapshot, $CRLF), ANY $WHITESPACE)
                        ELSE
                            'Assume a default date of just after midnight; in otherwords, "Today"
                            lsTmp                       =   DATE$
                            lsLastStatsSnapshot         =   RIGHT$(lsTmp, 4) + "-" + LEFT$(lsTmp, 5) + " 00:00:00"
                        END IF
                        
                        REM 'new data for this field
                            lsNowStatsSnapshot          =   StampItNowLogFmt
                            Redim                           lsaData( 1 to 3)
                            lsaData(1)                  =   "#Do not edit this file as it will be overwritten"
                            lsaData(2)                  =   ""
                            lsaData(3)                  =   lsLookFor + lsNowStatsSnapshot
                            sFilePut                        mABS_SRC + "\Moxie.stats.Last", Join$( lsaData(), $CrLf)
                            
                        REM 'Create our stats time stamp file for this run
                            lsData                      =   "StatsLast" + $TAB + "StatsNow" + $CRLF
                            lsData                      +=  lsLastStatsSnapshot + $Tab + lsNowStatsSnapshot
                            sFilePut                        ".\Moxie\Recv\" + format$(llFolderPathNum, "000") + ".snapshot.tab", lsData
                    End If
                    
                REM 'ServiceInit - Ensure Folders
                    if glLogRotate Then
                        sEnsureFolder                       "" , mDEST_BIN,     lsTmpLog   : lsResult += $CRLF + "sEnsureFolder: " + mDEST_BIN + lsTmpLog
                        sEnsureFolder                       "" , mDEST_LOG,     lsTmpLog   : lsResult += $CRLF + "sEnsureFolder: " + mDEST_LOG + lsTmpLog
                        sEnsureFolder                       "" , mDEST_DBSTORE, lsTmpLog   : lsResult += $CRLF + "sEnsureFolder: " + mDEST_DBSTORE + lsTmpLog
                        sEnsureFolder                       "" , mDEST_REPORTS, lsTmpLog   : lsResult += $CRLF + "sEnsureFolder: " + mDEST_REPORTS + lsTmpLog
                        sEnsureFolder                       "" , mDEST_WORK,    lsTmpLog   : lsResult += $CRLF + "sEnsureFolder: " + mDEST_WORK + lsTmpLog
                        mCommitLog
                    End If
                    
                REM 'AuxFoldersToZip - Every iteration
                    if glLogRotate Then
                    	'\Private\
                        lsCommand                       =   "IF EXIST " + $DQ + mDEST_3 + $DQ + " (DEL " + $DQ + mDEST_3 + $DQ+ ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        lsCommand                       =   "IF EXIST " + $DQ + mDEST_3 + ".*" + $DQ + " (DEL " + $DQ + mDEST_3 + ".*" + $DQ+ ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        lsCommand                       =   "7za a -tzip -r -ssw"
                        lsCommand                       +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                        lsCommand                       +=  " " + $DQ + mDEST_3 + $DQ
                        lsCommand                       +=  " " + $DQ + mSRC__3 + $DQ
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                        mCommitLog
                        Sleep 500
                        
                        '\Public\
                        lsCommand                       =   "IF EXIST " + $DQ + mDEST_4 + $DQ + " (DEL " + $DQ + mDEST_4 + $DQ+ ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        lsCommand                       =   "IF EXIST " + $DQ + mDEST_4 + ".*" + $DQ + " (DEL " + $DQ + mDEST_4 + ".*" + $DQ+ ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        lsCommand                       =   "7za a -tzip -v600m -r -ssw"
                        lsCommand                       +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                        lsCommand                       +=  " " + $DQ + mDEST_4 + $DQ
                        lsCommand                       +=  " " + $DQ + mSRC__4 + $DQ
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                        mCommitLog
                        Sleep 500
                        
                        '\Templates\
                        lsCommand                       =   "IF EXIST " + $DQ + mDEST_5 + $DQ + " (DEL " + $DQ + mDEST_5 + $DQ+ ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        lsCommand                       =   "IF EXIST " + $DQ + mDEST_5 + ".*" + $DQ + " (DEL " + $DQ + mDEST_5 + ".*" + $DQ+ ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        lsCommand                       =   "7za a -tzip -r -ssw"
                        lsCommand                       +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                        lsCommand                       +=  " " + $DQ + mDEST_5 + $DQ
                        lsCommand                       +=  " " + $DQ + mSRC__5 + $DQ
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                        mCommitLog
                        Sleep 500
                        
                    End If
                    
                REM 'ServiceStop
                    if glLogRotate OR glAllOff Then
                        lsCommand                       =   "NET STOP " + $DQ + lsaFolderPath(%ServiceName, llFolderPathNum) + $DQ
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotIncludes, "successfully")
                        mCommitLog
                    End If
                
                REM 'Perform Zip of Moxie Service and data folders
                    if glLogRotate Then
                        llPerformZip                    =   %False
                        llBrokenFlag                    =   %False
                        
                        REM 'Perform Daily on SSL enabled servers
                            IF VAL(lsaFolderPath(%HttpsPort, llFolderPathNum)) = 443  THEN
                                llPerformZip            =   %True
                            END IF
                            
                        REM 'Perform Saturday on ALL servers
                            IF LCASE$(GetDow(StampItDate)) = LCASE$("Sat") THEN
                                llPerformZip            =   %True
                            END IF
                        
                        IF llPerformZip THEN
                            REM 'Gather and zip all "Moxie" files
                                sGetFileNamesOnly           lsaFiles(), lsWork, %dir_Lib OR %dir_History
                                llC2                    =   0
                                For llC1 = 1 to UBOUND(lsaFiles)
                                    llFlag              =   %False 
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = "lib\"    Then Iterate for
                                    If lcase$( Right$( lsaFiles(llC1),  8)) = "history\" Then Iterate for
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = ".dll"    Then llFlag = %True
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = ".dat"    Then llFlag = %True
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = ".cfg"    Then llFlag = %True
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = ".exe"    Then llFlag = %True
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = ".mox"    Then llFlag = %True
                                    If lcase$( Right$( lsaFiles(llC1),  4)) = ".bat"    Then llFlag = %True
                                    IF llFlag = %False THEN iterate for
                                    Incr                    llC2
                                    lsaFiles(llC2)      =   lsaFiles(llC1)
                                Next
                                REDIM PRESERVE lsaFiles(1 TO llC2)
                                If llC2 THEN
                                    sFilePut                lsWork + $PreProcListFile, Join$( lsaFiles(), $Crlf)
                                    lsCommand           =   "7za a -tzip -ssw"
                                    lsCommand           +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                                    lsCommand           +=  " -i@" + $DQ + lsWork + $PreProcListFile + $DQ
                                    lsCommand           +=  " " + $DQ + mDEST_BIN + "\" + StampItDateHM + $DQ
                                    llBrokenFlag        =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                                    KILL                    lsWork + $PreProcListFile
                                    If llBrokenFlag Then
                                        glFinalResult   =   6
                                        gsFinalMessage  +=  $CRLF + "The following command failed. Proceeding..."
                                        gsFinalMessage  +=  $CRLF + lsCommand
                                    End If
                                ELSE
                                    lsResult            +=  $CRLF + "Error: sGetFileNamesOnly returned 0 files. 'Moxie' files were not zipped"
                                End If
                                
                                mCommitLog
                        END IF
                    END IF
                    
                REM 'Gather and zip all "DBStore" files and sub folders
                    if glLogRotate Then
                        lsCommand                       =   "7za a -tzip -r -ssw"
                        lsCommand                       +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                        lsCommand                       +=  " " + $DQ + mDEST_2 + $DQ
                        lsCommand                       +=  " " + $DQ + mSRC__2 + $DQ
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                        If llBrokenFlag Then
                            glFinalResult               =   7
                            gsFinalMessage              +=  $CRLF + "The following command failed. Proceeding..."
                            gsFinalMessage              +=  $CRLF + lsCommand
                        End If
                        
                        mCommitLog
                    End If
                
                REM 'Gather and zip all "Work" files and sub folders but only if the "Work" folder exists
                    if glLogRotate Then
                        if LEN( DIR$(lsWork + "Work\")) THEN
                            'lsCommand                   =   "7za a -tzip -v600m -r -ssw"
                            lsCommand                   =   "7za a -tzip -v600m -r -ssw -x!*.pdf"
                            lsCommand                   +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                            lsCommand                   +=  " " + $DQ + mDEST_6 + $DQ
                            lsCommand                   +=  " " + $DQ + mSRC__6 + $DQ
                            llBrokenFlag                =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                            If llBrokenFlag Then
                                glFinalResult           =   7
                                gsFinalMessage          +=  $CRLF + "The following command failed. Proceeding..."
                                gsFinalMessage          +=  $CRLF + lsCommand
                            End If
                        End If
                        
                        mCommitLog
                    End If
                
                REM 'Gather and PreProcess "log" files that fall between lsLastStatsSnapshot & StampItNowLogFmt for later processing for later processing
                    If glLogStats then
                        sGetFileNamesOnly                   lsaFiles(), lsWork, %dir_History
                        llC2                            =   0
                        For llC1 = 1 to UBOUND(lsaFiles)
                            If lcase$( Right$( lsaFiles(llC1), 4)) <> ".log" Then Iterate for
                            Incr                            llC2
                            lsaFiles(llC2)              =   lsWork + lsaFiles(llC1)
                        Next
                        REDIM                               PRESERVE lsaFiles(1 TO llC2)
                        If llC2 THEN
                            GatherLogFilesAndPreProcess     lsaFolderPath(), llFolderPathNum, lsaFiles(), lsResult
                        ELSE
                            lsResult                    +=  $CrLf + "Error: No log files seen for " + lsWork
                        End If
                        
                        mCommitLog
                    End If
                    
                REM 'Gather and PreProcess "stats" files that fall between lsLastStatsSnapshot & StampItNowLogFmt for later processing for later processing
                    If glLogStats then
                        sGetFileNamesOnly                   lsaFiles(), lsWork, %dir_History
                        llC2                            =   0
                        For llC1 = 1 to UBOUND(lsaFiles)
                            If                              lcase$( Right$( lsaFiles(llC1), 6)) <> ".stats" Then Iterate for
                            Incr                            llC2
                            lsaFiles(llC2)              =   lsWork + lsaFiles(llC1)
                        Next
                        REDIM                               PRESERVE lsaFiles(1 TO llC2)
                        If llC2 THEN
                            Redim                           lsaTmp( 1 to llC2), lsaSrt( 1 to llC2)
                            Redim                           lsaData( 1 to %MAXstatsFIELDS, 1 to llC2)
                            
                            For llC1 = 1 to UBOUND(lsaFiles)
                                
                                sFileGet                    lsaFiles(llC1), lsTmp, llLOF
                                
                                lsaData( %statsStatTime, llC1)      =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsStatTime         ), $CRLF))
                                lsaData( %statsMoxieVer, llC1)      =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsMoxieVer         ), $CRLF))
                                lsaData( %statsHttpState, llC1)     =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsHttpState        ), $CRLF))
                                lsaData( %statsHttpsState, llC1)    =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsHttpsState       ), $CRLF))
                                lsaData( %statsBkRecvState, llC1)   =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsBkRecvState      ), $CRLF))
                                lsaData( %statsSrvHits, llC1)       =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsSrvHits          ), $CRLF))
                                lsaData( %statsSrvCurrent, llC1)    =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsSrvCurrent       ), $CRLF))
                                lsaData( %statsSrvPeek, llC1)       =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsSrvPeek          ), $CRLF))
                                lsaData( %statsSrvCompleted, llC1)  =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsSrvCompleted     ), $CRLF))
                                lsaData( %statsSrvUnique, llC1)     =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsSrvUnique        ), $CRLF))
                                lsaData( %statsSrvUniquePeek, llC1) =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsSrvUniquePeek    ), $CRLF))
                                lsaData( %statsClientRead, llC1)    =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsClientRead       ), $CRLF))
                                lsaData( %statsClientWrite, llC1)   =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsClientWrite      ), $CRLF))
                                lsaData( %statsBackupRead, llC1)    =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsBackupRead       ), $CRLF))
                                lsaData( %statsBackupWrite, llC1)   =   TRIM$( EXTRACT$( REMAIN$( lsTmp, $statsBackupWrite      ), $CRLF))
                                
                                For llC3 = 1 to %MAXstatsFIELDS
                                    lsaTmp( llC1)       +=  $Tab + lsaData( llC3, llC1)
                                Next
                                lsaTmp( llC1)           =   TRIM$( lsaTmp( llC1), $Tab)
                                
                                lsaSrt( llC1)           =   lsaData( %statsStatTime, llC1)  + $Tab + _
                                                            format$(llFolderPathNum, "000") + _
                                                            Format$(llC2, "0000000")
                                
                            Next
                            
                            ARRAY SORT lsaSrt(), COLLATE UCASE, TAGARRAY lsaTmp()
                            For llC2 = 1 to llC1
                                lsaTmp( llC2)           =   format$(llFolderPathNum, "000") + Format$(llC2, "0000000") + $Tab + lsaTmp( llC2)
                            Next
                            
                            lsData                      =   JOIN$( lsaTmp(), $CRLF)
                            REPLACE                         $CRLF WITH chr$(0) IN lsData
                            REPLACE                         $Tab WITH chr$(1) IN lsData
                            sFilePut                        ".\Moxie\Recv\" + format$(llFolderPathNum, "000") + ".stats.cnd", lsData
                            Reset                           lsData
                            
                            lsTmp                       =  "Alias" + chr$(1) + "Alias"              + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F01"   + chr$(1) + "F01StatTime"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F02"   + chr$(1) + "F02MoxieVer"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F03"   + chr$(1) + "F03HttpState"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F04"   + chr$(1) + "F04HttpsState"      + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F05"   + chr$(1) + "F05BkRecvState"     + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F06"   + chr$(1) + "F06SrvHits"         + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F07"   + chr$(1) + "F07SrvCurrent"      + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F08"   + chr$(1) + "F08SrvPeek"         + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F09"   + chr$(1) + "F09SrvCompleted"    + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F10"   + chr$(1) + "F10SrvUnique"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F11"   + chr$(1) + "F11SrvUniquePeek"   + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F12"   + chr$(1) + "F12ClientRead"      + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F13"   + chr$(1) + "F13ClientWrite"     + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F14"   + chr$(1) + "F14BackupRead"      + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       += "F15"   + chr$(1) + "F15BackupWrite"     + chr$(1) + "" + chr$(1) + "[R]" + chr$(1)
                            
                            sFilePut                        ".\Moxie\Recv\stats.cnt", TRIM$( lsTmp, chr$(0))
                            Reset                           lsTmp
                            
                        ELSE
                            lsResult                    +=   $CrLf + "Error: No stats files seen for " + lsWork
                        End If
                        
                        mCommitLog
                    End If
                
                REM 'Gather and PreProcess "Exception" file dates and flag them that fall between lsLastStatsSnapshot & StampItNowLogFmt for later processing
                    ' Filename format
                    '  Exception-2014-05-05-011925-Default.dll.dat
                    '  Exception-2014-05-05-011925-Moxie.dll.dat
                    '  Exception-2014-05-05-011925-Moxie.exe.dat
                    If glLogStats then
                        sGetFileNamesOnly                   lsaFiles(), lsWork, %dir_History
                        llC2                            =   0
                        For llC1 = 1 to UBOUND(lsaFiles)
                            If lcase$( Right$( lsaFiles(llC1), 4)) <> ".dat" Then Iterate for
                            If lcase$( LEFT$( lsaFiles(llC1), 9)) <> "exception" Then Iterate for
                            Incr                            llC2
                            lsaFiles(llC2)              =   lsWork + lsaFiles(llC1)
                        Next
                        REDIM                               PRESERVE lsaFiles(1 TO llC2)
                        If llC2 THEN
                            REM 'Parse and convert filename time stamp to find out when the exception occured
                                For llC3 = 1 to llC2
                                    lsT2                =   LEFT$( lsaFiles(llC3), (INSTR( -1, lsaFiles(llC3), "-") - 1))
                                    lsT2                =   remain$( lsT2, "-")
                                    '(convert 2014-06-09-150400 -> 2014-06-09 15:04:00)
                                    lsT1                =   left$( lsT2, 10)
                                    lsT1                +=  " " + MID$( lsT2, 12, 2)
                                    lsT1                +=  ":" + MID$( lsT2, 14, 2)
                                    lsT1                +=  ":" + MID$( lsT2, 16, 2)
                                    
                                    REM 'If the fimestamp is in the past, assume that it has been reported already
                                        'If  (DateTimeToQuad(lsT1) <= DateTimeToQuad( lsNowStatsSnapshot)) _
                                        'AND (DateTimeToQuad(lsT1) => DateTimeToQuad( lsLastStatsSnapshot)) _
                                        'THEN
                                        If  (DateTimeToQuad(lsT1) => DateTimeToQuad( lsLastStatsSnapshot)) THEN
                                            lsResult        +=  $Crlf + "Error: Exceptions found " + lsaFiles(llC3)
                                            glFinalResult   =   8
                                            gsFinalMessage  +=  $Crlf + "Error: Exceptions found " + lsaFiles(llC3)
                                        End If
                                Next
                        ELSE
                            ' Fall through as this is a good thing
                        End If
                        
                        mCommitLog
                    End If
                
                REM 'Move old reports to the backup area
                    if glLogRotate Then
                        IF LCASE$(GetDow(StampItDate)) = LCASE$("Sat") THEN
                            if LEN( DIR$(lsWork + "Private\Report Results\")) THEN
                                sGetFileNamesOnly           lsaFiles(), lsWork + "Private\Report Results\", 0
                                llC2                    =   0
                                REDIM                       lsaDest( 1 to UBOUND(lsaFiles))
                                For llC1 = 1 to UBOUND(lsaFiles)
                                    lsTmp               =   DIR$(lsWork + "Private\Report Results\" + lsaFiles(llC1) TO tddDirData)
                                    tiPowerTime         =   CLASS "PowerTime"
                                    tiPowerTime.FileTime =  tddDirData.CreationTime   ' tiPowerTime contains the file creation time in a localized format.
                                    lsT1                =   tiPowerTime.DateString
                                    tiPowerTime.AddMonths       2
                                    lsT2                =   tiPowerTime.DateString
                                    If lsT2 > StampItDate Then Iterate for
                                    Incr                    llC2
                                    lsaDest(llC2)       =   $DQ + mDEST_REPORTS + "\" + $DQ
                                    lsaFiles(llC2)      =   $DQ +  lsaFiles(llC1) + $DQ
                                Next
                                REDIM                       PRESERVE lsaFiles(1 TO llC2)
                                REDIM                       PRESERVE lsaDest(1 TO llC2)
                                If llC2 THEN
                                    REM 'Prep the 'local' folder
                                        lsOrigFldr      =   RTRIM$( CURDIR$, ANY " \") + "\"
                                        lsWorkFldr      =   lsWork + "Private\Report Results\"
                                        
                                        If lsOrigFldr <> lsWorkFldr THEN
                                            CHDRIVE         Extract$(lsWorkFldr, ":")
                                            chdir           REMAIN$(lsWorkFldr, ":")
                                        End If
                                        
                                    For llC1 = 1 to llC2
                                        lsCommand       =   "MOVE /Y " + lsaFiles(llC1) + " " + lsaDest(llC1)
                                        llBrokenFlag    =   ResultFlagOnShellExec( "ShellExec", lsWork, "", lsCommand, lsResult, $FlagIfNotIncludes, "1 file(s) moved")
                                    NEXT
                                    
                                    REM ' Restore the 'local' folder
                                        If lsOrigFldr <> lsWorkFldr THEN
                                            CHDRIVE         Extract$(lsOrigFldr, ":")
                                            chdir           REMAIN$(lsOrigFldr, ":")
                                        End If
                                    
                                End If
                            End If
                        end if
                    End If
                
                REM 'Zip/Move/Save logs: If success, then delete them from the lsaFolderPath()
                    if glLogRotate Then
                        sGetFileNamesOnly                   lsaFiles(), lsWork, %dir_History OR %dir_DBStore
                        'Require two versions of lsaFiles(),
                        ' 1st lsaFiles1() is what gets zipped/saved
                        ' 2nd lsaFiles2() is what gets deleted
                        
                        llC21                         	=   0
                        llC22							=	0
                        
                        REDIM lsaFiles1(1 TO UBOUND(lsaFiles))
                        REDIM lsaFiles2(1 TO UBOUND(lsaFiles))
                        
                        For llC1 = 1 to UBOUND(lsaFiles)
                            llFlag1                     =   %False 
                            llFlag2                     =   %False 
                            If lcase$( Right$( lsaFiles(llC1), 4))  = ".log" Then
                            	llFlag1					=	%True
                            	llFlag2					=	%True
                            End If
                            If lcase$( Right$( lsaFiles(llC1), 4))  = ".dat" Then
                            	llFlag1					=	%True
                            	llFlag2					=	%True
                            End If
                            If lcase$( Right$( lsaFiles(llC1), 6))  = ".stats" Then
                            	llFlag1					=	%True
                            	llFlag2					=	%True
                            End If
                            If ((lcase$( Right$( lsaFiles(llC1), 11)) = "session.cnd") AND (lcase$( Right$( lsaFiles(llC1), 15)) <> "biz.session.cnd")) Then
                            	llFlag1					=	%True
        						If MetaSearch( lsaMeta(), llFolderPathNum, "Session") <> "NoReset" Then
                            		llFlag2				=	%True
                            	End If
                            End If
                            If lcase$( Right$( lsaFiles(llC1), 10)) = ".TwoFactor" Then
                            	llFlag1					=	%True
                            	llFlag2					=	%True
                            End If
                            lsTmp							=	lsWork + lsaFiles(llC1)
                            IF llFlag1 = %True THEN
	                            Incr                            llC21
	                            lsaFiles1(llC21)           =   lsTmp
	                        End If
                            IF llFlag2 = %True THEN
	                            Incr                            llC22
	                            lsaFiles2(llC22)           =   lsTmp
	                        End If
                        Next
                        lsResult                    +=  $CrLf + "counts " + format$(UBOUND(lsaFiles)) + " " + format$(llC21) + " " + format$(llc22)
                        
                        REDIM PRESERVE lsaFiles1(1 TO llC21)
                        REDIM PRESERVE lsaFiles2(1 TO llC22)
                        
                        If llC21 THEN
                            sFilePut                        lsWork + $PreProcListFile, Join$( lsaFiles1(), $Crlf)
                            lsResult                    +=  $CrLf + "<PreProcListFile Archiving>" + Join$( lsaFiles1(), ", ") + "</PreProcListFile>"
                            lsCommand                   =   "7za a -tzip -ssw"
                            lsCommand                   +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                            lsCommand                   +=  " -i@" + $DQ + lsWork + $PreProcListFile + $DQ
                            lsCommand                   +=  " " + $DQ + mDEST_LOG + "\" + StampItDateHM + ".zip"+ $DQ
                            llBrokenFlag                =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                            KILL                            lsWork + $PreProcListFile
                            
                            REM 'Test to ensure "Everything is Ok" prior to deleting original (unZipped) file(s)
                                If llBrokenFlag = %False Then
                                	'The zipping occurrs into a tmp file which is then copied into the final file
                                	'The test occurs on the final file
                                    'Therefore, we need a 1 sec timer to ensure that the final file is completely written
                                    '
                                    SLEEP 1000
                                	lsCommand           =   "7za t -tzip"
                                    lsCommand           +=  " " + $DQ + mDEST_LOG + "\" + StampItDateHM + ".zip"+ $DQ
                                    llBrokenFlag        =   ResultFlagOnShellExec( "ShellExec7za", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotIncludes, "Everything is Ok")
                                    IF llBrokenFlag = 0 THEN
                                        'Only if everything is good can we delete the orig files
                                        'lsResult        +=  $CrLf + "<PreProcListFile Deleting>" + Join$( lsaFiles(), ", ") + "</PreProcListFile>"
                                        'sFilePut            lsWork + $PreProcListFile, Join$( lsaFiles(), $Crlf)
                                        'lsCommand       =   "FOR /F %I IN (" + lsWork + $PreProcListFile + ") DO DEL " + $DQ + "%I" + $DQ
                                        'llBrokenFlag    =   ResultFlagOnShellExec( "ShellExec", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotEmpty, "")
                                        'KILL                lsWork + $PreProcListFile
                                        
                                        lsResult        +=  $CrLf + "<PreProcListFile Deleting>" + Join$( lsaFiles2(), ", ") + "</PreProcListFile>"
                                        sFilePut            lsWork + $PreProcListFile, Join$( lsaFiles2(), $Crlf)
                                        lsCommand       =   "FOR /F %I IN (" + lsWork + $PreProcListFile + ") DO DEL " + $DQ + "%I" + $DQ
                                        llBrokenFlag    =   ResultFlagOnShellExec( "ShellExec", lsWork, lsHomeFldr, lsCommand, lsResult, $FlagIfNotEmpty, "")
                                        KILL                lsWork + $PreProcListFile
                                        
                                    ELSE
                                        'We have a broken zip file
                                        llBrokenFlag    =   %True
                                    END IF
                                ELSE
                                    'We have a broken zip file
                                    llBrokenFlag        =   %True
                                END IF
                        
                                IF llBrokenFlag = %True THEN
                                    'If we have a broken zip file
                                    lsResult            +=  $CRLF + "Error: 7za Failure: log file did not compress properly. Original log file intact."
                                END IF
                        ELSE
                            lsResult                    +=  $CRLF + "Error: sGetFileNamesOnly returned 0 files. 'Zip/Move/Save logs' files were not zipped"
                        End If
                        
                        mCommitLog
                    End If
                
                REM 'Remove old TwoFactor file
                    if glLogRotate Then
                        KILL                                lsWork + "Moxie.TwoFactor"
                    End If
                    
                REM 'Perform RunNightly.mox if found
                    if glLogRotate Then
                        IF LEN( DIR$(lsWork + "RunNightly.mox")) THEN
                            REM 'Perform Daily on SSL enabled servers or not
                                IF VAL(lsaFolderPath(%HttpsPort, llFolderPathNum)) = 443  THEN
                                    lsCommand           =   "CD /D " + $DQ + lsWork + $DQ + " && Moxie.exe " + $DQ + "RunNightly.mox?TwoFactorAudit=y" + $DQ
                                ELSE
                                    lsCommand           =   "CD /D " + $DQ + lsWork + $DQ + " && Moxie.exe " + $DQ + "RunNightly.mox" + $DQ
                                END IF
                                
                                llBrokenFlag            =   ResultFlagOnShellExec( "ShellExec", lsWork, lsHomeFldr, lsCommand, lsResult, $Ignore, "")
                                
                                mCommitLog
                        END IF
                    End If
                
                REM 'Gather and PreProcess all "TwoFactor" files for later processing
                    if glLogRotate Then
                        IF LEN( DIR$(lsWork + "Moxie.TwoFactor")) THEN
                            sFileGet                        lsWork + "Moxie.TwoFactor", lsData, llLof
                            lsData                      =   REMAIN$( lsData, $Crlf)
                            
                            llC1                        =   parsecount( lsData, $CRLF)
                            Redim                           lsaTmp( 1 to llC1)
                            Parse                           lsData, lsaTmp(), $CRLF
                            Reset                           lsData
                            
                            For llC2 = 1 to llC1        :   ' insert an Alias field
                                lsaTmp( llC2)           =   format$(llFolderPathNum, "000") + Format$(llC2, "0000000") + $Tab + lsaTmp( llC2)
                            NEXT
                            
                            lsData                      =   Join$( lsaTmp(), $CrLf)
                            
                            REPLACE                         $CRLF WITH chr$(0) IN lsData
                            REPLACE                         $Tab WITH chr$(1) IN lsData
                            sFilePut                        ".\Moxie\Recv\" + format$(llFolderPathNum, "000") + ".twofactor.cnd", lsData
                            Reset                           lsData
                            
                            
                            lsTmp                       =   "Alias" + chr$(1) + "Alias"         + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       +=  "F01"   + chr$(1) + "F01Site"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       +=  "F02"   + chr$(1) + "F02Type"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       +=  "F03"   + chr$(1) + "F03ID"         + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       +=  "F04"   + chr$(1) + "F04Handle"     + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       +=  "F05"   + chr$(1) + "F05Name"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
                            lsTmp                       +=  "F06"   + chr$(1) + "F06TwoFactor"  + chr$(1) + "" + chr$(1) + "[R]" + chr$(1)
                            
                            sFilePut                        ".\Moxie\Recv\twofactor.cnt", TRIM$( lsTmp, chr$(0))            
                            Reset                           lsTmp
                            
                            lsResult                    +=  $CrLf + "Moxie.TwoFactor PreProcessed"
                        END IF
                    End If
                
                REM 'Remove DBStore files that are marked for deletion (DBStore\*.del)
                    if glLogRotate Then
                        lsCommand                       =   "IF EXIST " + $DQ + lsWork + "DBStore\*.del"+ $DQ + " (DEL " + $DQ + lsWork + "DBStore\*.del"+ $DQ + ")"
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotEmpty, "")
                        mCommitLog
                    End If
                
                REM 'Force Email-if-serious-error address
                    if glLogRotate Then
                        lsFile                          =   lsWork + "DBStore\Setup.cnd"
                        sFileGet                            lsFile, lsData, llLOF
                        
                        llC1                            =   parsecount( lsData, $SEP_NUL)
                        Redim                               lsaTmp( 1 to llC1)
                        Redim                               lsaData( 1 to llC1)
                        Parse                               lsData, lsaTmp(), $SEP_NUL
                        
                        Rem 'Remove old Setup values
                            llC2                        =   0
                            For llC3 = 1 to llC1
                                SELECT CASE AS CONST$ Lcase$( Extract$( lsaTmp(llC3), $SEP_SOH))
                                    Case "cnw.emailerrfrom", "cnw.emailerrto", "cnw.emailipadminfrom", "cnw.emailipadminto"
                                        'punt these values in favour of below values
                                    Case else
                                        Incr llC2
                                        lsaData(llC2)   =   lsaTmp(llC3)
                                End Select
                            Next
                            REDIM PRESERVE                  lsaData( 1 TO llC2)
                            lsData                      =   join$( lsaData(), $SEP_NUL)
                            
                        Rem 'Append New Setup Values or default values if no Meta flag given
                        	lsTmp						=	MetaSearch( lsaMeta(), llFolderPathNum, "Cnw.EmailErrFrom")
                        	If Len( lsTmp) Then
                        		lsData					+=  $SEP_NUL + "Cnw.EmailErrFrom"       + $SEP_SOH + lsTmp
                        	Else
                            	lsData                  +=  $SEP_NUL + "Cnw.EmailErrFrom"       + $SEP_SOH + lsForceCnwEmailErr
                            End If
                            
                        	lsTmp						=	MetaSearch( lsaMeta(), llFolderPathNum, "Cnw.EmailErrTo")
                        	If Len( lsTmp) Then
                        		lsData					+=  $SEP_NUL + "Cnw.EmailErrTo"        	+ $SEP_SOH + lsTmp
                        	Else
                            	lsData                  +=  $SEP_NUL + "Cnw.EmailErrTo"       	+ $SEP_SOH + lsForceCnwEmailErr
                            End If
                            
                        	lsTmp						=	MetaSearch( lsaMeta(), llFolderPathNum, "Cnw.EmailIPAdminFrom")
                        	If Len( lsTmp) Then
                        		lsData					+=  $SEP_NUL + "Cnw.EmailIPAdminFrom"   + $SEP_SOH + lsTmp
                        	Else
                            	lsData                  +=  $SEP_NUL + "Cnw.EmailIPAdminFrom"   + $SEP_SOH + lsForceCnwEmailErr
                            End If
                            
                        	lsTmp						=	MetaSearch( lsaMeta(), llFolderPathNum, "Cnw.EmailIPAdminTo")
                        	If Len( lsTmp) Then
                        		lsData					+=  $SEP_NUL + "Cnw.EmailIPAdminTo"   	+ $SEP_SOH + lsTmp
                        	Else
                            	lsData                  +=  $SEP_NUL + "Cnw.EmailIPAdminTo"   	+ $SEP_SOH + lsForceCnwEmailErr
                            End If
                            
                        Rem 'Maintain Moxie Sort
                            llC1                        =   parsecount( lsData, $SEP_NUL)
                            Redim                           lsaData( 1 to llC1)
                            Parse                           lsData, lsaData(), $SEP_NUL
                            ARRAY SORT                      lsaData(), COLLATE UCASE
                            lsData                      =   join$( lsaData(), $SEP_NUL)
                            
                        sFilePut                            lsFile, lsData
                        
                        lsResult                        +=  $CrLf + "EmailForced: " + lsForceCnwEmailErr + " " + lsFile
                        mCommitLog
                    End If
                    
                REM 'ServiceStart
                    if glLogRotate OR glAllOn Then
                        lsCommand                       =   "NET START " + $DQ + lsaFolderPath(%ServiceName, llFolderPathNum) + $DQ
                        llBrokenFlag                    =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $FlagIfNotIncludes, "successfully")
                        mCommitLog
                    End If
                
                lsResult += $CRLF + lsFooter
                mCommitLog
                
            ELSE
                IF LEN( lsaFolderPath(%FolderRoot, llFolderPathNum)) THEN
                    lsResult                            +=  $CRLF + "ShellExecResult: " + lsWork + " might not be configured properly, check the ServiceName and UserName"
                    glFinalResult                       =   4
                    gsFinalMessage                      +=  $CRLF + "ShellExecResult: " + lsWork + " might not be configured properly, check the ServiceName and UserName. Proceeding..."
                    CommitLog lsHomeFldr, lsResult      :   '** NOTE ** Do not exit on error!!
                END IF
            END IF
        NEXT
        
        REM 'Post processing of earlier Stats snapshots
            If glLogStats then
                FinalizeLog                                 UBOUND( lsaFolderPath(2))
                FinalizeStats                               UBOUND( lsaFolderPath(2))
                'ConductAudit                           :   'Done with MoxLogsRecv.mox
                'CommitAudit                            :   'Done with MoxLogsRecv.mox
            End If
            
        REM 'Post processing of earlier Log snapshots
            If glLogRotate then
                FinalizeTwoFactor                           UBOUND( lsaFolderPath(2))
            End If
            
        REM 'Perform MoxLogsRecv.mox to do final processing and push stats into server
            IF LEN( DIR$(lsHomeFldr + "Moxie\Moxie.PreProc.mox")) THEN
                If glLogRotate or glLogStats THEN
                    'NOTE: This is a batch file, it has to be executed as:
                    ' Moxie.exe "Moxie.PreProc.mox?Stamp=2014-07-04-1800&Stats=y&Rotate=y&MoxieOnError=Server.Admin@topdomain.top"
                    lsCommand                           =   "CD /D " + $DQ + lsHomeFldr + "Moxie" + $DQ + " && Moxie.exe " + $DQ + "Moxie.PreProc.mox"
                    lsCommand                           +=  "?Stamp=" & StampItDateHM
                    lsCommand                           +=  IIF$( glLogStats,  "&Stats=y", "&Stats=")
                    lsCommand                           +=  IIF$( glLogRotate, "&Rotate=y", "&Rotate=")
                    lsCommand                           +=  IIF$( glLogRotate, "&MoxieOnError=" & lsMoxieOnError, "&MoxieOnError=")
                    lsCommand                           +=  $DQ
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", lsWork, lsHomeFldr, lsCommand, lsResult, $Ignore, "")
                    mCommitLog
                END IF
            END IF
            
        REM 'Create and send email detailing failure/success codes then return Final Result code
           PrematureExit:
            
            Select Case as const glFinalResult
                case 0      : llIsCritical = %False     : 
                CASE 1      : llIsCritical = %True      :   gsFinalMessage  +=  $CRLF + "Invalid command line arguments. "
                                                            gsFinalMessage  +=  $CRLF + " " + lsCommand
                                                            gsFinalMessage  +=  $CRLF + "Command line syntax is:"
                                                            gsFinalMessage  +=  $CRLF + " c:\Util\PreProc>%comspec% /z /c PreProc /logrotate /stats /quiet"
                                                            gsFinalMessage  +=  $CRLF + "Or if run as a task:"
                                                            gsFinalMessage  +=  $CRLF + " PreProc /logrotate /stats /quiet [ with path set to: c:\Util\PreProc ]" 
                                                            
                                                            'As CASE 1 can be triggered by improper command line options, allow a printed final result
                                                            sFilePut        "PreProc.FinalResult.log", TRIM$(gsFinalMessage, $CRLF)
                    
                case 2      : llIsCritical = %False     :   'text has been handled already
                case 3      : llIsCritical = %True      :   'text has been handled already
                case 4      : llIsCritical = %True      :   'text has been handled already
                case 5      : llIsCritical = %True      :   'text has been handled already
                case 6      : llIsCritical = %True      :   'text has been handled already
                case 7      : llIsCritical = %True      :   'text has been handled already
                case 8      : llIsCritical = %True      :   'text has been handled already
                case else   : llIsCritical = %True      :   gsFinalMessage  +=  $CRLF + "An un-handled message (gsFinalMessage = " + format$(glFinalResult) + ") has occured; hope thats ok."
            End Select
            
            If glLogQuiet THEN
                CommitLog                                   lsHomeFldr, TRIM$( lsResult, $CRLF) + $CRLF + TRIM$( gsFinalMessage, $CRLF)
            Else
                REM 'Make Email Header, Message, etc
                    lsEmailSubject                      =   "[PreProc] " + ENVIRON$("COMPUTERNAME") + " " + IIF$(llIsCritical, "Error", "Success")
                    lsPreProcEmail                      =   "[MAIL SERVER]"                     + $CRLF + Trim$( lsMailServer, $CRLF)      + $CRLF + $CRLF
                    lsPreProcEmail                      +=  "[MAIL SERVER PORT]"                + $CRLF + Trim$( lsMailServerPort, $CRLF)  + $CRLF + $CRLF
                    lsPreProcEmail                      +=  "[FROM]"                            + $CRLF + Trim$( lsMailFrom, $CRLF)        + $CRLF + $CRLF
                    lsPreProcEmail                      +=  "[SUBJECT]"                         + $CRLF + Trim$( lsEmailSubject, $CRLF)    + $CRLF + $CRLF
                    lsPreProcEmail                      +=  "[EMAIL MESSAGE]"                   + $CRLF + Trim$( gsFinalMessage, $CRLF)    + $CRLF + "[END]" + $CRLF + $CRLF
                    IF llIsCritical = %False Then
                        lsData                          =   lsEmailNoError
                    ELSE
                        lsData                          =   lsEmailOnError
                    END IF
                    
                REM 'Send email. One per address. Remove empty addresses.
                    llC1                                =   parsecount( lsData, $CRLF)
                    llC3                                =   0
                    Redim                                   lsaData( 1 to llC1)
                    Parse                                   lsData, lsaData(), $CRLF
                    for llC2 = 1 to llC1
                        lsTmp                           =   trim$( lsaData( llC2), ANY $WHITESPACE)
                        if len( lsTmp) THEN
                            incr                            llC3
                            lsaData( llC3)              =   lsTmp
                        End If
                    Next
                    If llC3 Then
                        for llC2 = 1 to llC3
                            sFilePut                        "PreProc.Email", lsPreProcEmail + "[SEND TO (ONE ADDRESS PER LINE)]"  + $CRLF + lsaData( llC2) + $CRLF + "[END]"
                            SHELL                           ENVIRON$("COMSPEC") + " /C  PwrMail.exe PreProc.email 2>&1" , 0
                            KILL                            "PreProc.Email"
                        nEXT
                    End If
            End If
            
            mCommitLog
            
        REM 'Move/Zip PreProc, MoxView & MoxLogsRecv.mox logs: 1x/day
            if glLogRotate Then
                'Clear LOCAL memory space
                    lsResult                            =   ""
                    lsTmp                               =   ""
                    lsDest                              =   lsBackupRootFolder + "zPreProc\" + StampItDateHM + ".zip"
                    
                'Amalgamate all xxx.log.tab files into one (use MergeTabFiles.bas code)
                    For llFolderPathNum = 1 to UBOUND( lsaFolderPath(2))
                        sFileGet                            ".\Moxie\Recv\" + format$(llFolderPathNum, "000") + ".log.tab", lsData, llLof
                        if llFolderPathNum = 1 then         lsHeader = Extract$( lsData, $CRLF)
                        lsTmp                           +=  $CRLF + REMAIN$( lsData, $CRLF)
                    Next
                    lsData                              =   ""
                    sFilePut                                ".\Moxie\Recv\log.tab", lsHeader + $crlf + Trim$( lsTmp, $CRLF)
                    lsTmp                               =   ""
                    
                'move all PreProc logs into Moxie\Recv\PreProc folder
                    lsCommand                           =   "MKDIR " + lsHomeFldr + "Moxie\Recv\PreProc"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", "",  "", lsCommand, lsResult, $Ignore, "")
                    
                    lsCommand                           =   "MOVE /Y " + ".\PreProc\*.*" + " " + ".\Moxie\Recv\PreProc"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $Ignore, "")
                    
                'Copy SendGrid results into Moxie\Recv folder folder
                    lsCommand                           =   "COPY /Y " + ".\Moxie\Work\SendGrid\*.tab" + " " + ".\Moxie\Recv"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $Ignore, "")
                    
                'Move all Moxie logs into Moxie\Recv\Moxie folder folder
                    lsCommand                           =   "MKDIR " + lsHomeFldr + "Moxie\Recv\Moxie"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", "",  "", lsCommand, lsResult, $Ignore, "")
                    
                    lsCommand                           =   "MOVE /Y " + ".\Moxie\History\*.*" + " " + ".\Moxie\Recv\Moxie"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", "", "", lsCommand, lsResult, $Ignore, "")
            End If
                    
            if glLogRotate OR glAllOff OR glAllOn Then
                'Parse lsMoxViewFolder - Moxie.cfg to find the ServiceName
                    sFileGet                               lsMoxViewFolder + "Moxie.cfg", lsData, llLen
                    lsFile                              =   TRIM$( EXTRACT$( REMAIN$( lsData, $cfgServiceName ), $CRLF))
            End If
                    
            if glLogRotate OR glAllOff Then
                'Stop MoxView
                    lsCommand                           =   "NET STOP " + $DQ + lsFile + $DQ
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", lsMoxViewFolder, "", lsCommand, lsResult, $Ignore, "")
            End If
                    
            if glLogRotate Then
                'Move all MoxView\History into Moxie\Recv\MoxView folder
                    lsCommand                           =   "MKDIR " + lsHomeFldr + "Moxie\Recv\MoxView"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", "",  "", lsCommand, lsResult, $Ignore, "")
                    
                    lsCommand                           =   "MOVE /Y " + lsMoxViewFolder + "History\*.*" + " " + lsHomeFldr + "Moxie\Recv\MoxView"
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", lsMoxViewFolder,  "", lsCommand, lsResult, $Ignore, "")
            End If
                    
            if glLogRotate OR glAllOn Then
                'Start MoxView
                    lsCommand                           =   "NET START " + $DQ + lsFile + $DQ
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec", lsMoxViewFolder, "", lsCommand, lsResult, $Ignore, "")
            End If
                    
            if glLogRotate Then
                'Perform Zip of Recv and move into C:\Backup\PreProc
                    lsCommand                           =   "7za a -tzip -r -ssw"
                    lsCommand                           +=  " -w" + $DQ + lsHomeFldr + $ProgramName + $DQ
                    lsCommand                           +=  " " + $DQ + lsDest + $DQ
                    lsCommand                           +=  " " + $DQ + lsHomeFldr + "Moxie\Recv" + $DQ
                    llBrokenFlag                        =   ResultFlagOnShellExec( "ShellExec7za", "", lsHomeFldr, lsCommand, lsResult, $Ignore, "")
            End If
                    
            if glLogRotate OR glAllOff OR glAllOn Then
                'leave everything in Recv as it will be removed on the next run
                    sFilePut                                "PreProc.FinalResult.log", TRIM$(lsResult, $CRLF)
            End If
            
            FUNCTION                                    =   glFinalResult
    END FUNCTION
    
REM SubRoutines
    
    SUB FinalizeTwoFactor( plFolderCount AS LONG)
        local lsData, lsHeader, lsaHeader() as string
        local llC1, llC2, llSite, llLof as long
        
        Rem 'create header for log.tab
            sFileGet                                        ".\Moxie\Recv\twofactor.cnt", lsHeader, llLof
            KILL                                            ".\Moxie\Recv\twofactor.cnt"
            
            llC1                                        =   parsecount( lsHeader, $SEP_NUL)
            Redim                                           lsaHeader( 1 to llC1)
            parse                                           lsHeader, lsaHeader(), $SEP_NUL
            for llC2 = 1 to llC1
                lsaHeader( llC2)                        =   parse$( lsaHeader( llC2), $SEP_SOH, 2)
            Next
            
        REM 'Per Site
            For llSite = 1 to plFolderCount
                if DIR$(".\Moxie\Recv\" + format$(llSite, "000") + ".twofactor.cnd") = format$(llSite, "000") + ".twofactor.cnd" THEN
                    REM 'This iterations data
                        sFileGet                            ".\Moxie\Recv\" + format$(llSite, "000") + ".twofactor.cnd", lsData, llLof
                        KILL                                ".\Moxie\Recv\" + format$(llSite, "000") + ".twofactor.cnd"
                        
                    Rem 'Pack and save all data for the Moxie program & posterity
                        Replace                             $SEP_NUL with $CRLF in lsData
                        Replace                             $SEP_SOH with $TAB in lsData
                        sFilePut                            ".\Moxie\Recv\" + format$(llSite, "000") + ".twofactor.tab", join$( lsaHeader(), $Tab) + $crlf + lsData
                End If
            Next
    end sub
    
    SUB FinalizeStats( plFolderCount AS LONG)
        local lsData, lsHeader, lsaHeader() as string
        local llC1, llC2, llSite, llLof as long
        
        Rem 'create header for log.tab
            sFileGet                                        ".\Moxie\Recv\stats.cnt", lsHeader, llLof
            KILL                                            ".\Moxie\Recv\stats.cnt"
            
            llC1                                        =   parsecount( lsHeader, $SEP_NUL)
            Redim                                           lsaHeader( 1 to llC1)
            parse                                           lsHeader, lsaHeader(), $SEP_NUL
            for llC2 = 1 to llC1
                lsaHeader( llC2)                        =   parse$( lsaHeader( llC2), $SEP_SOH, 2)
            Next
            
        REM 'Per Site
            For llSite = 1 to plFolderCount
                REM 'This iterations data
                    sFileGet                                ".\Moxie\Recv\" + format$(llSite, "000") + ".stats.cnd", lsData, llLof
                    KILL                                    ".\Moxie\Recv\" + format$(llSite, "000") + ".stats.cnd"
                    
                Rem 'Pack and save all data for the Moxie program & posterity
                    Replace                                 $SEP_NUL with $CRLF in lsData
                    Replace                                 $SEP_SOH with $TAB in lsData
                    sFilePut                                ".\Moxie\Recv\" + format$(llSite, "000") + ".stats.tab", join$( lsaHeader(), $Tab) + $crlf + lsData
            Next
    end sub
    
    SUB FinalizeLog( plFolderCount AS LONG)
        local lsFolderPath, lsIP1, lsIP2, lsIP3, lsIP4, lsData, lsaData(), lsCtry, lsaCtry(), lsaCountry(), lsCtryHeader, lsTmp, lsaTmp(), lsFinal, lsHeader, lsaHeader(), lsLastStatsSnapshot as string
        local llC1, llC2, llC3, llLof, llSite, llCtryCount as long
        local ldData, ldaCtry(), ldaCtry2() as dword
            
        Rem 'create header for log.tab
            'note: the default sort order is 'most recent entry last'
            sFileGet                                        ".\Moxie\Recv\log.cnt", lsHeader, llLof
            KILL                                            ".\Moxie\Recv\log.cnt"
            
            llC1                                        =   parsecount( lsHeader, $SEP_NUL)
            Redim                                           lsaHeader( 1 to llC1)
            parse                                           lsHeader, lsaHeader(), $SEP_NUL
            for llC2 = 1 to llC1
                lsaHeader( llC2)                        =   parse$( lsaHeader( llC2), $SEP_SOH, 2)
            Next
            
        REM 'IPv4ToCountry: Load and prep for searches
            sFileGet                                        ".\IpToCountry\Ip2Country.tab", lsCtry, llLof
            lsCtryHeader                                =   Extract$( lsCtry, $CRLF)
            lsCtry                                      =   remain$( lsCtry, $CRLF)
            llCtryCount                                 =   parsecount( lsCtry, $CRLF)
            
            Redim                                           lsaCtry( 1 to llCtryCount)
            Redim                                           lsaCountry( 1 to llCtryCount)
            Redim                                           ldaCtry( 1 to llCtryCount)
            Redim                                           ldaCtry2( 1 to llCtryCount)
            Parse                                           lsCtry, lsaCtry(), $CRLF
            
            For llC1 = 1 to llCtryCount
                ldaCtry(llC1)                           =   val( parse$( lsaCtry(llC1), $Tab, 1))
            Next
            ARRAY SORT ldaCtry(), TAGARRAY lsaCtry()
            For llC1 = 1 to llCtryCount
                ldaCtry2(llC1)                          =   val( parse$( lsaCtry(llC1), $Tab, 2))
                lsaCountry(llC1)                        =        parse$( lsaCtry(llC1), $Tab, 7)
            Next
            
        REM 'Per Site
            For llSite = 1 to plFolderCount
                
                REM 'This iterations snapshot datestamp
                    sFileGet                                ".\Moxie\Recv\" + format$(llSite, "000") + ".snapshot.tab", lsData, llLof
                    lsLastStatsSnapshot                 =   Remain$( lsData, $CRLF)
                    lsLastStatsSnapshot                 =   EXTRACT$( lsLastStatsSnapshot, $TAB)
                    
                REM 'This iterations data
                    sFileGet                                ".\Moxie\Recv\" + format$(llSite, "000") + ".log.cnd", lsData, llLof
                    KILL                                    ".\Moxie\Recv\" + format$(llSite, "000") + ".log.cnd"
                    llC1                                =   parsecount( lsData, $SEP_NUL)
                    Redim                                   lsaData( 1 to %Tedata + 1, 1 to llC1)
                    Redim                                   lsaTmp( 1 to llC1)
                    
                    Parse                                   lsData, lsaTmp(), $SEP_NUL
                    
                    For llC2 = 1 to llC1
                        For llC3 = 1 to %Tedata
                            lsaData( llC3, llC2)        =   parse$( lsaTmp( llC2), $SEP_SOH, llC3)
                        Next
                    Next
                    
                REM 'IP address lookup is done by using IP10 values
                    'http://stackoverflow.com/questions/10668831/how-to-efficiently-index-and-search-ipv4-address-ranges-in-c-sharp
                    'http://en.wikipedia.org/wiki/Binary_search_algorithm#Recursive
                    For llC2 = 1 to llC1
                        If LEN( lsaData( %F09eIPNum, llC2)) _
                        AND "127.0.0.1"         <> lsaData( %F09eIPNum, llC2) _
                        AND "ECom"              <> lsaData( %F05eCategory, llC2) _
                        AND lsLastStatsSnapshot <= lsaData( %F03eTimeStamp, llC2) _
                        Then
                            lsIP1                       =   parse$( lsaData( %F09eIPNum, llC2), ".", 1)
                            lsIP2                       =   parse$( lsaData( %F09eIPNum, llC2), ".", 2)
                            lsIP3                       =   parse$( lsaData( %F09eIPNum, llC2), ".", 3)
                            lsIP4                       =   parse$( lsaData( %F09eIPNum, llC2), ".", 4)
                            ldData                      =   (val(lsIP1) * 16777216) + (val(lsIP2) * 65536) + (val(lsIP3) * 256) + val(lsIP4)
                            
                            Rem 'for a given data record, find where it fits between in an Ctry record
                                For llC3 = 1 to llCtryCount
                                    If ldData => ldaCtry(llC3) _
                                    AND ldData < ldaCtry2(llC3) _
                                    THEN
                                        lsaData( %F21eCountry, llC2) = lsaCountry(llC3)
                                        exit
                                    END IF
                                NEXT
                        End If
                    Next
                    
                REM 'Pack and save this iterations data
                    For llC2 = 1 to llC1
                        lsaTmp( llC2)                   =   lsaData( %F00eAlias              , llC2) + $Tab + _
                                                            lsaData( %F01eFolderName         , llC2) + $Tab + _
                                                            lsaData( %F02eLogLocation        , llC2) + $Tab + _
                                                            lsaData( %F03eTimeStamp          , llC2) + $Tab + _
                                                            lsaData( %F04eThread             , llC2) + $Tab + _
                                                            lsaData( %F05eCategory           , llC2) + $Tab + _
                                                            lsaData( %F06eMessage            , llC2) + $Tab + _
                                                            lsaData( %F07eDetails            , llC2) + $Tab + _
                                                            lsaData( %F08eBytes              , llC2) + $Tab + _
                                                            lsaData( %F09eIPNum              , llC2) + $Tab + _
                                                            lsaData( %F10eThreadNum          , llC2) + $Tab + _
                                                            lsaData( %F11eThreadTime         , llC2) + $Tab + _
                                                            lsaData( %F12ePersonUUID         , llC2) + $Tab + _
                                                            lsaData( %F13eSessionUUID        , llC2) + $Tab + _
                                                            lsaData( %F14eDatum1             , llC2) + $Tab + _
                                                            lsaData( %F15eDatum2             , llC2) + $Tab + _
                                                            lsaData( %F16eDatum3             , llC2) + $Tab + _
                                                            lsaData( %F17eDatum4             , llC2) + $Tab + _
                                                            lsaData( %F18eMessageCode        , llC2) + $Tab + _
                                                            lsaData( %F19eMoxVerMajor        , llC2) + $Tab + _
                                                            lsaData( %F20eMoxVerMinor        , llC2) + $Tab + _
                                                            lsaData( %F21eCountry            , llC2)
                    Next
                    
                Rem 'Pack and save all data for the Moxie program & posterity
                    sFilePut                                ".\Moxie\Recv\" + format$(llSite, "000") + ".log.tab", join$( lsaHeader(), $Tab) + $crlf + Join$( lsaTmp(), $CrLf)
            Next
    END SUB
    
    FUNCTION UpdateTally( psIndex AS STRING, psaIndex() AS STRING, psaTally() AS STRING) AS LONG
        LOCAL lsIndex AS STRING
        LOCAL llIndex, llC1 AS LONG
        
        llIndex                                         =   UBOUND(psaIndex(1))
        lsIndex                                         =   TRIM$(psIndex)
        
        IF LEN(lsIndex) THEN
            IF llIndex THEN
                FOR llC1 = 1 TO llIndex
                    IF  psaIndex(llC1) = lsIndex THEN       EXIT FOR
                NEXT
                IF llC1 > llIndex THEN
                    INCR                                    llIndex
                    REDIM                                   PRESERVE psaIndex(1 TO llIndex), psaTally(1 TO llIndex)
                    psaIndex(llIndex)                   =   lsIndex
                    psaTally(llIndex)                   =   FORMAT$(1)
                    ARRAY SORT                              psaIndex(), COLLATE UCASE, TAGARRAY psaTally()
                ELSEIF psaIndex(llC1) = lsIndex THEN
                    psaTally(llC1)                      =   FORMAT$(VAL(psaTally(llC1)) + 1)
                END IF
            ELSE
                INCR llIndex
                REDIM psaIndex(1 TO llIndex), psaTally(1 TO llIndex)
                psaIndex(1)                             =   lsIndex
                psaTally(1)                             =   FORMAT$(1)
            END IF
        END IF
    END FUNCTION
    
    SUB GatherLogFilesAndPreProcess( psaFolderPath() as string, plFolderPathNum as long, psaFiles() as string, psResult as string)
        LOCAL lsaFiles() AS STRING
        LOCAL lsVerMajor, lsVerMinor, lsTmp, lsaTmp(), lsaSrt(), lsTemp, lsData, lsaData() as string
        LOCAL llC1, llC2, llC3, llC4, llLOF AS LONG
        
        REM 'seperate all the log files found into lines
            For llC1 = 1 to UBOUND(psaFiles)
                sFileGet                                    psaFiles(llC1), lsTmp, llLOF
                lsTmp                                   =   Trim$( lsTmp, $CRLF)
                llC4                                    =   parsecount( lsTmp, $CRLF)
                Redim                                       lsaTmp( 1 to llC4)
                Parse                                       lsTmp, lsaTmp(), $CRLF
                For llC3 = 1 to llC4
                    lsaTmp(llC3)                        =   psaFolderPath( %FolderObject, plFolderPathNum) + $Tab + psaFiles(llC1) + $Tab + lsaTmp(llC3)
                Next
                lsData                                  +=  Join$( lsaTmp(), $CRLF) + $CRLF
            Next
        
        lsData                                          =   Trim$( lsData, $Crlf)
        
        REM 'and now start to make a single tab delimited table
            llC1                                        =   parsecount( lsData, $CRLF)
            
            Redim                                           lsaTmp( 1 to llC1)
            Parse                                           lsData, lsaTmp(), $CRLF
            Reset                                           lsData
            
            Redim                                           lsaData( 1 to %Tdata, 1 to llC1)
            For llC2 = 1 to llC1
                For llC3 = 1 to %Tdata
                    lsaData( llC3, llC2)                =   PARSE$(lsaTmp(llC2), $TAB, llC3)
                Next
            NEXT
            RESET                                           lsaTmp()
            
        REM 'While everything is in sequence, save the Moxie Version decryption key
            For llC2 = 1 to llC1
                Select Case as const$ LCASE$( lsaData( %F05_Category , llC2))
                    case    "-server started-", "-server stopped-", "-cmdmox started-", "-cmdmox stopped-"
                            lsVerMajor = ""
                            lsVerMinor = ""
                            
                    case    "moxie version"
                            lsVerMajor = Extract$( lsaData( %F06_Message, llC2), " ")
                            lsVerMinor = remain$(  lsaData( %F06_Message, llC2), " ")
                            
                    CASE    "http", "https"
                            llC4       = Val( Extract$( lsaData( %F06_Message, llC2), " "))
                            If llC4 Then lsaData( %F18_MessageCode, llC2) = format$( llC4)
                            
                    CASE    "run time error"    :   'Deconstruct any run time error
                            lsaData( %F06_Message, llC2) = _
                                lsaData( %F06_Message       , llC2) + $SEP_TAB + _
                                lsaData( %F07_Details       , llC2) + $SEP_TAB + _
                                lsaData( %F08_Bytes         , llC2) + $SEP_TAB + _
                                lsaData( %F09_IPNum         , llC2) + $SEP_TAB + _
                                lsaData( %F10_ThreadNum     , llC2) + $SEP_TAB + _
                                lsaData( %F11_ThreadTime    , llC2) + $SEP_TAB + _
                                lsaData( %F12_PersonUUID    , llC2) + $SEP_TAB + _
                                lsaData( %F13_SessionUUID   , llC2) + $SEP_TAB + _
                                lsaData( %F14_Datum1        , llC2) + $SEP_TAB + _
                                lsaData( %F15_Datum2        , llC2) + $SEP_TAB + _
                                lsaData( %F16_Datum3        , llC2) + $SEP_TAB + _
                                lsaData( %F17_Datum4        , llC2) + $SEP_TAB + _
                                lsaData( %F18_MessageCode   , llC2) + $SEP_TAB
                                
                            lsaData( %F06_Message, llC2) = TRIM$( lsaData( %F06_Message, llC2), $SEP_TAB)
                                lsaData( %F07_Details       , llC2) = ""
                                lsaData( %F08_Bytes         , llC2) = ""
                                lsaData( %F09_IPNum         , llC2) = ""
                                lsaData( %F10_ThreadNum     , llC2) = ""
                                lsaData( %F11_ThreadTime    , llC2) = ""
                                lsaData( %F12_PersonUUID    , llC2) = ""
                                lsaData( %F13_SessionUUID   , llC2) = ""
                                lsaData( %F14_Datum1        , llC2) = ""
                                lsaData( %F15_Datum2        , llC2) = ""
                                lsaData( %F16_Datum3        , llC2) = ""
                                lsaData( %F17_Datum4        , llC2) = ""
                                lsaData( %F18_MessageCode   , llC2) = ""
                            
                    CASE    "login"        :   'Reconstruct Login
                            lsaData( %F12_PersonUUID, llC2) = lsaData( %F09_IPNum,   llC2)        :   lsaData( %F09_IPNum,   llC2) = ""
                            lsaData( %F15_Datum2,     llC2) = lsaData( %F08_Bytes,   llC2)        :   lsaData( %F08_Bytes,   llC2) = ""
                            lsaData( %F14_Datum1,     llC2) = lsaData( %F07_Details, llC2)        :   lsaData( %F07_Details, llC2) = ""
                            
                    CASE    "bademail"     :   'Reconstruct BadEmail
                            lsaData( %F16_Datum3,     llC2) = lsaData( %F09_IPNum,   llC2)        :   lsaData( %F09_IPNum,   llC2) = ""
                            lsaData( %F15_Datum2,     llC2) = lsaData( %F08_Bytes,   llC2)        :   lsaData( %F08_Bytes,   llC2) = ""
                            lsaData( %F14_Datum1,     llC2) = lsaData( %F07_Details, llC2)        :   lsaData( %F07_Details, llC2) = ""
                            
                    Case else
                End Select
                
                lsaData( %F19_MoxVerMajor  , llC2)      =   lsVerMajor
                lsaData( %F20_MoxVerMinor  , llC2)      =   lsVerMinor
            Next
            
        REM 'F07 breakdown details into datum with error flag
            For llC2 = 1 to llC1
                If Val( lsaData( %F18_MessageCode, llC2)) Then
                    lsaData( %F14_Datum1, llC2)         =   lcase$( Extract$( lsaData( %F07_Details, llC2), " "))
                    lsTmp                               =   lcase$( REMAIN$( lsaData( %F07_Details, llC2), " "))
                    
                    lsaData( %F17_Datum4, llC2)         =   REMAIN$( lsTmp, " ")
                    lsTmp                               =   Extract$( lsTmp, " ")
                    
                    lsaData( %F15_Datum2, llC2)         =   Extract$( lsTmp, "?")
                    lsaData( %F16_Datum3, llC2)         =   REMAIN$( lsTmp, "?")
                End If
                
                Select Case as const$ LCASE$( lsaData( %F17_Datum4, llC2))
                    case    "http/1.1", "http/1.0"
                            'Fall Through
                    Case else
                            If len( lsaData( %F18_MessageCode, llC2)) Then lsaData( %F17_Datum4, llC2)    =   "*"
                End Select
                
                Select Case as const$ LCASE$( lsaData( %F14_Datum1, llC2))
                    case    "connect", "trace", "delete", "put", "post", "head", "get", "options"
                            'Fall Through
                    Case else
                            If len( lsaData( %F18_MessageCode, llC2)) Then lsaData( %F17_Datum4, llC2)    =   "*"
                End Select
            Next
            
        REM 'Prep, sort and apply an Alias
            Redim                                           lsaTmp( 1 to llC1), lsaSrt( 1 to llC1)
            For llC2 = 1 to llC1
                lsaSrt( llC2)                           =   lsaData( %F03_TimeStamp, llC2)  + $Tab + _
                                                            format$(plFolderPathNum, "000") + _
                                                            Format$(llC2, "0000000")
                                 
                lsaTmp( llC2)                           =   lsaData( %F01_FolderName       , llC2) + $Tab + _
                                                            lsaData( %F02_LogLocation      , llC2) + $Tab + _
                                                            lsaData( %F03_TimeStamp        , llC2) + $Tab + _
                                                            lsaData( %F04_Thread           , llC2) + $Tab + _
                                                            lsaData( %F05_Category         , llC2) + $Tab + _
                                                            lsaData( %F06_Message          , llC2) + $Tab + _
                                                            lsaData( %F07_Details          , llC2) + $Tab + _
                                                            lsaData( %F08_Bytes            , llC2) + $Tab + _
                                                            lsaData( %F09_IPNum            , llC2) + $Tab + _
                                                            lsaData( %F10_ThreadNum        , llC2) + $Tab + _
                                                            lsaData( %F11_ThreadTime       , llC2) + $Tab + _
                                                            lsaData( %F12_PersonUUID       , llC2) + $Tab + _
                                                            lsaData( %F13_SessionUUID      , llC2) + $Tab + _
                                                            lsaData( %F14_Datum1           , llC2) + $Tab + _
                                                            lsaData( %F15_Datum2           , llC2) + $Tab + _
                                                            lsaData( %F16_Datum3           , llC2) + $Tab + _
                                                            lsaData( %F17_Datum4           , llC2) + $Tab + _
                                                            lsaData( %F18_MessageCode      , llC2) + $Tab + _
                                                            lsaData( %F19_MoxVerMajor      , llC2) + $Tab + _
                                                            lsaData( %F20_MoxVerMinor      , llC2) + $Tab + _
                                                            lsaData( %F21_Country          , llC2)
                                 
            NEXT
            
            ARRAY SORT                                      lsaSrt(), COLLATE UCASE, TAGARRAY lsaTmp()
            
            For llC2 = 1 to llC1
                lsaTmp( llC2)                           =   format$(plFolderPathNum, "000") + Format$(llC2, "0000000") + $Tab + lsaTmp( llC2)
            Next
                
            Reset lsaData()
            
            lsData                                      =   Join$( lsaTmp(), $CRLF)
            Reset                                           lsaTmp()
            
            REPLACE                                         $CRLF WITH chr$(0) IN lsData
            REPLACE                                         $Tab WITH chr$(1) IN lsData
            sFilePut                                        ".\Moxie\Recv\" + format$(plFolderPathNum, "000") + ".log.cnd", lsData
            
            lsTmp  = "Alias" + chr$(1) + "Alias"            + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F01"   + chr$(1) + "F01FolderName"    + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F02"   + chr$(1) + "F02LogLocation"   + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F03"   + chr$(1) + "F03TimeStamp"     + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F04"   + chr$(1) + "F04Thread"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F05"   + chr$(1) + "F05Category"      + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F06"   + chr$(1) + "F06Message"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F07"   + chr$(1) + "F07Details"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F08"   + chr$(1) + "F08Bytes"         + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F09"   + chr$(1) + "F09IPNum"         + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F10"   + chr$(1) + "F10ThreadNum"     + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F11"   + chr$(1) + "F11ThreadTime"    + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F12"   + chr$(1) + "F12PersonUUID"    + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F13"   + chr$(1) + "F13SessionUUID"   + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F14"   + chr$(1) + "F14Datum1"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F15"   + chr$(1) + "F15Datum2"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F16"   + chr$(1) + "F16Datum3"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F17"   + chr$(1) + "F17Datum4"        + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F18"   + chr$(1) + "F18MessageCode"   + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F19"   + chr$(1) + "F19MoxVerMajor"   + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F20"   + chr$(1) + "F20MoxVerMinor"   + chr$(1) + "" + chr$(1) + "[R]" + chr$(1) + chr$(0)
            lsTmp += "F21"   + chr$(1) + "F21Country"       + chr$(1) + "" + chr$(1) + "[R]" + chr$(1)
            
            sFilePut                                        ".\Moxie\Recv\log.cnt", TRIM$( lsTmp, chr$(0))            
            Reset                                           lsTmp
    END SUB
    
    SUB sGetFileNamesOnly( psaFiles() AS STRING, psFolder AS STRING, plSubFolders as long)
        LOCAL llC1 AS LONG
        Local lsFolder, lsThisFile as string
        REDIM                                               psaFiles(1 TO 10) : llC1 = 1
        'Start with the current (default) directory
            lsFolder = ""                               :   Gosub FillAndLoop
            
        'Check each possable directory using bitwise AND
            If ( plSubFolders AND %dir_DBStore  ) Then lsFolder = "DBStore"     :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_History  ) Then lsFolder = "History"     :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_Lib      ) Then lsFolder = "Lib"         :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_Private  ) Then lsFolder = "Private"     :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_Public   ) Then lsFolder = "Public"      :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_Recv     ) Then lsFolder = "Recv"        :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_Templates) Then lsFolder = "Templates"   :   Gosub FillAndLoop
            If ( plSubFolders AND %dir_Work     ) Then lsFolder = "Work"        :   Gosub FillAndLoop
        
        REDIM                                               PRESERVE psaFiles(1 TO llC1 - 1)
        Exit                                                Sub
        
        FillAndLoop:
            If Len(lsFolder) Then
                psaFiles(llC1)                          =   lsFolder + "\" + DIR$(TRIM$(psFolder, "\") + "\" + lsFolder + "\*.*")
            Else
                psaFiles(llC1)                          =   DIR$(TRIM$(psFolder, "\") + "\*.*")
            End If
            DO
                INCR llC1
                IF llC1 > UBOUND(psaFiles) THEN             REDIM PRESERVE psaFiles(1 TO llC1 * 1.5)
                lsThisFile                              =   DIR$
                If Len(lsFolder) Then
                    psaFiles(llC1)                      =   lsFolder + "\" + lsThisFile
                Else
                    psaFiles(llC1)                      =   lsThisFile
                End If
            LOOP WHILE LEN(lsThisFile)
        Return
    END SUB
    
    Function ShellExec( psWorkFldr AS STRING, psHomeFldr as string, psShellCommand AS STRING, psShellCommandResult AS STRING) as long
        LOCAL llLen AS LONG
        LOCAL lsPreProcFilePath AS STRING
        
        IF psWorkFldr = "" THEN
            lsPreProcFilePath                           =   ".\" + $PreProcTempFile
        ELSE
            lsPreProcFilePath                           =   RTRIM$( TRIM$(psWorkFldr), ANY " \") + "\" + $PreProcTempFile
        END IF
        
        IF INSTR(lsPreProcFilePath, $SPC) THEN
            lsPreProcFilePath                           =   $DQ + lsPreProcFilePath + $DQ
        END IF
        
        KILL lsPreProcFilePath  :   'Remove any prevously failed temp file
        SHELL                                               ENVIRON$("COMSPEC") + " /C " + psShellCommand + " > " & lsPreProcFilePath & " 2>&1", 0
        
        sFileGet                                            lsPreProcFilePath, psShellCommandResult, llLen
        sFilePut                                            lsPreProcFilePath, ""
        KILL                                                lsPreProcFilePath
        
        REM ' Some programs do not play nice with DOS Error messages
            REPLACE                                         $CR + $CR WITH $CR IN psShellCommandResult
            psShellCommandResult                        =   RTRIM$( psShellCommandResult, $CRLF)
    END FUNCTION
    
    FUNCTION ShellExec7za( _                            :   ' Set's up a "local" environment so that the 7za command can use relative file paths
                    psWorkFldr AS STRING, _             :   ' Set this to be the 'current folder' for the 7za command to execute
                    _                                       ' it cannot be empty and must be an absolute path
                    _                                       ' The original folder is restored automatically on return
                    psHomeFldr as string, _             :   ' Where our 7za.exe file is. Cannot be empty.
                    psShellCommand AS STRING, _         :   ' The DOS command to execute
                    psShellCommandResult AS STRING _    :   ' The results of the command
                    ) as long
        LOCAL llLen, llRet, llErr AS LONG
        local lsWorkFldr, lsHomeFldr, lsOrigFldr, lsData as string
        
        llErr                                           =   %False
        
        lsWorkFldr                                      =   RTRIM$( psWorkFldr, ANY " \") + "\"
        lsHomeFldr                                      =   RTRIM$( psHomeFldr, ANY " \") + "\"
        lsOrigFldr                                      =   RTRIM$( CURDIR$, ANY " \") + "\"
        
        REM ' Basic error checking and init
            If psWorkFldr = "\" _
            OR psHomeFldr = "\" _
            OR LEN( DIR$(psHomeFldr + "7za.exe")) = 0 THEN
                llErr                                   =   %True
                GOTO                                        ShellExec7zaDone
            END IF
            
            If lsHomeFldr = lsWorkFldr THEN
                llErr                                   =   %True
                GOTO                                        ShellExec7zaDone
            END IF
            
        REM 'Prep the 'local' folder
            If lsOrigFldr <> lsWorkFldr THEN
                CHDRIVE                                     Extract$(psWorkFldr, ":")
                chdir                                       REMAIN$(psWorkFldr, ":")
            End If
            
        REM 'Prep the 7za command to execute as a 'local' command with our current privelige level
            sFileGet                                        lsHomeFldr + "7za.exe", lsData, llLen
            If llLen < 2 THEN
                llErr                                   =   %True
                GOTO                                        ShellExec7zaDone
            End If
            sFilePut                                        lsWorkFldr + "7za.exe", lsData
            KILL                                            "7za.tmp"  :   'Remove any prevously failed zip tmp file
            
            SHELL                                           ENVIRON$("COMSPEC") + " /C " + psShellCommand + " > 7za.tmp 2>&1" , 0
            sFileGet                                        "7za.tmp", psShellCommandResult, llLen
            sFilePut                                        "7za.tmp", ""
            KILL                                            "7za.tmp"
            KILL                                            lsWorkFldr + "7za.exe"
        
        REM ' Restore
            If lsOrigFldr <> lsWorkFldr THEN
                CHDRIVE                                     Extract$(lsOrigFldr, ":")
                chdir                                       REMAIN$(lsOrigFldr, ":")
            End If
        
        REM ' Some programs do not play nice with DOS Error messages
            REPLACE                                         $CR + $CR WITH $CR IN psShellCommandResult
            psShellCommandResult                        =   RTRIM$( psShellCommandResult, $CRLF)
            
        REM ' Done
            ShellExec7zaDone:
            FUNCTION                                    =   llErr
    END FUNCTION
        
    FUNCTION ResultFlagOnShellExec( _
                    psCommand as string, _              :   '
                    psWorkFldr AS STRING, _             :   '
                    psHomeFldr as string, _             :   '
                    psShellCommand AS STRING, _         :   '
                    psResultLog AS STRING, _            :   '
                    psFailFlagCriteria AS STRING, _     :   '
                    psFailFlagTestString AS STRING _    :   '
                    ) AS LONG
        GLOBAL glFinalResult AS LONG
        global gsFinalMessage as string
        LOCAL llFailFlag, llErrorFlag AS LONG
        LOCAL lsTmpLog, lsResult, lsResultMessage, lsFailFlagTestString AS STRING
        
        llErrorFlag                                     =  %False
        
        If      LCASE$( psCommand) = LCASE$( "ShellExec") Then
            psResultLog                                 +=  $CRLF + "ShellExec: " + psShellCommand
            llErrorFlag                                 =  ShellExec( psWorkFldr, psHomeFldr, psShellCommand, lsTmpLog)
            
        Elseif LCASE$( psCommand) = LCASE$( "ShellExec7za") Then
            psResultLog                                 +=  $CRLF + "ShellExec7za: " + psShellCommand
            llErrorFlag                                 =  ShellExec7za( psWorkFldr, psHomeFldr, psShellCommand, lsTmpLog)
            
        ELSE
            psResultLog                                 +=  $CRLF + "ResultFlagOnShellExec: Error: invalid command " + psShellCommand
            llErrorFlag                                 =  %True
            goto                                            ResultFlagOnShellExecDone
        End If
    
        lsResult                                        =   LCASE$(lsTmpLog)
        lsResult                                        =   TRIM$( lsResult)
        lsResult                                        =   TRIM$( lsResult, $TAB)
        lsResult                                        =   TRIM$( lsResult, $CRLF)
        lsResult                                        =   TRIM$( lsResult, $CR)
        lsResult                                        =   TRIM$( lsResult, $LF)
    
        lsFailFlagTestString                            =   LCASE$( psFailFlagTestString)
        llFailFlag                                      =   INSTR( lsResult, lsFailFlagTestString)
    
        SELECT CASE psFailFlagCriteria
            CASE $Ignore
                ' Fall Through
                
            CASE $FlagIfEmpty
                IF LEN( lsResult) = 0 THEN
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command " & psFailFlagCriteria
                END IF
                
            CASE $FlagIfNotEmpty
                IF LEN( lsResult) <> 0 THEN
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command " & psFailFlagCriteria
                END IF
                
            CASE $FlagIfIncludes
                IF LEN(lsFailFlagTestString) = 0 THEN
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command " & psFailFlagCriteria & " Invalid Test"
                END IF
                IF llFailFlag <> 0 THEN
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command " & psFailFlagCriteria
                ELSE
                    ' Fall Through
                END IF
                
            CASE $FlagIfNotIncludes
                IF LEN(lsFailFlagTestString) = 0 THEN
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command " & psFailFlagCriteria & " Invalid Test"
                END IF
                IF llFailFlag = 0 THEN
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command " & psFailFlagCriteria
                ELSE
                    ' Fall Through
                END IF
    
            CASE ELSE
                    llErrorFlag   = %True               :   lsResultMessage = "Error: " + psCommand + " Command $UnHandled"
        END SELECT
        
        REPLACE                                             $CRLF WITH  $SEP_CRLF IN lsTmpLog
        REPLACE                                             $CR WITH    $SEP_CR   IN lsTmpLog
        REPLACE                                             $LF WITH    $SEP_LF   IN lsTmpLog
        
        IF psFailFlagCriteria = $Ignore THEN
            psResultLog                                 +=  $CRLF + "ResultFlagOnShellExec: " + "$Ignore" + "<ResultFlagOnShellExec>" + lsTmpLog + "</ResultFlagOnShellExec>"
        ELSE
            psResultLog                                 +=  $CRLF + "ResultFlagOnShellExec: " + lsResultMessage + "<ResultFlagOnShellExec>" + lsTmpLog + "</ResultFlagOnShellExec>"
        END IF
        
        ResultFlagOnShellExecDone:
        IF llErrorFlag THEN
            glFinalResult                               =   5
            gsFinalMessage                              +=  $CRLF + "Non fatal command failure: " + lsResultMessage + ". See logs; proceeding..."
        End If
        FUNCTION = llErrorFlag
    END FUNCTION
    
    SUB sCaptureConfiguration( psWorkFldr AS STRING, _  :   '
                    psaFolderPath() AS STRING, _        :   '
                    psBackupRootFolder as string, _     :   '
                    psStatsRecvFolder as string, _      :   '
                    psMoxViewFolder as string, _        :   '
                    psMailServer as string, _           :   '
                    psMailServerPort as string, _       :   '
                    psMailFrom as string, _             :   '
                    psForceCnwEmailErr as string, _     :   '
                    psEmailOnError as string, _         :   '
                    psEmailNoError as string, _         :   '
                    psMoxieOnError as string)
        GLOBAL glFinalResult AS LONG
        LOCAL llLen, llFlag, llC1, llC2, llC3, llC4, llC5, llC6 AS LONG
        LOCAL lsPreProcCfgPath, lsPreProcData, lsPreProcCfgData, lsData, lsaData(), lstmp1, lstmp2 AS STRING
        LOCAL lsFolderPath, lsaFolderPath(), lsLookFor, lsLookForResult, lsObjectRootFolder, lsBackupRootFolder AS STRING
        
        REDIM                                               lsaFolderPath(0), lsaData(0)
        
        REM 'parse config file for object directories
            sFileGet                                        psWorkFldr + $PreProcCfgName, lsPreProcCfgData, llLen
            IF llLen < 2 THEN
                lsPreProcCfgData                        =   ""
                lsPreProcCfgData                        +=  $CRLF + "# ------------------------------- PreProc.conf ------------------------"
                lsPreProcCfgData                        +=  $CRLF + "# Emails below are one email per line; as many lines as required"
                lsPreProcCfgData                        +=  $CRLF + "# no more comments below this line"
                lsPreProcCfgData                        +=  $CRLF + "# ---------------------------------------------------------------------"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[ObjectRootFolder]"
                lsPreProcCfgData                        +=  $CRLF + "U:\Work"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[BackupRootFolder]"
                lsPreProcCfgData                        +=  $CRLF + "C:\Backup3"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[StatsRecvFolder]"
                lsPreProcCfgData                        +=  $CRLF + "C:\Work\Logs.WebNnow.cc\Recv"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[MoxViewFolder]"
                lsPreProcCfgData                        +=  $CRLF + "D:\Util\MoxView"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[MailServer]"
                lsPreProcCfgData                        +=  $CRLF + "mail.topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[MailServerPort]"
                lsPreProcCfgData                        +=  $CRLF + "65536"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[MailFrom]"
                lsPreProcCfgData                        +=  $CRLF + "server@topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[Force.Cnw.EmailErr]"
                lsPreProcCfgData                        +=  $CRLF + "Server.Admin@topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[EmailOnError]"
                lsPreProcCfgData                        +=  $CRLF + "Server.Admin@topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + "The.Boss@topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[EmailNoError]"
                lsPreProcCfgData                        +=  $CRLF + "Server.Admin@topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + ""
                lsPreProcCfgData                        +=  $CRLF + "[MoxieOnError]"
                lsPreProcCfgData                        +=  $CRLF + "Server.Admin@topdomain.top"
                lsPreProcCfgData                        +=  $CRLF + ""
                sFilePut                                    psWorkFldr + $PreProcCfgName, Trim$( lsPreProcCfgData, $CRLF)
                lsObjectRootFolder                      =   ""
                glFinalResult                           =   2
                gsFinalMessage                          +=  $CRLF + "A config file was not found; the following suggested configuration file was created. Please edit it before running again."
                gsFinalMessage                          +=  $CRLF + lsPreProcCfgData
            ELSE
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[ObjectRootFolder]"   : GOSUB ParseConfigParam   : lsObjectRootFolder = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[BackupRootFolder]"   : GOSUB ParseConfigParam   : lsBackupRootFolder = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[StatsRecvFolder]"    : GOSUB ParseConfigParam   : psStatsRecvFolder  = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[MoxViewFolder]"      : GOSUB ParseConfigParam   : psMoxViewFolder    = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[MailServer]"         : GOSUB ParseConfigParam   : psMailServer       = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[MailServerPort]"     : GOSUB ParseConfigParam   : psMailServerPort   = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[MailFrom]"           : GOSUB ParseConfigParam   : psMailFrom         = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[Force.Cnw.EmailErr]" : GOSUB ParseConfigParam   : psForceCnwEmailErr = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[EmailOnError]"       : GOSUB ParseConfigParam   : psEmailOnError     = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[EmailNoError]"       : GOSUB ParseConfigParam   : psEmailNoError     = lsLookForResult
                lsLookForResult                         =   lsPreProcCfgData : lsLookFor = "[MoxieOnError]"       : GOSUB ParseConfigParam   : psMoxieOnError     = lsLookForResult
                
                psBackupRootFolder						=	lsBackupRootFolder
            END IF
            
        REM 'Capture Configuration Info
            IF lsObjectRootFolder = "" THEN
                REDIM                                       psaFolderPath(0)
                EXIT                                        SUB
            ELSE
                ShellExec                                   "", "", "DIR /AD /B " + lsObjectRootFolder, lsPreProcData
                llC1                                    =   PARSECOUNT(lsPreProcData, $CRLF)
                REDIM                                       psaFolderPath(1 TO %MAXcfgFIELDS, 1 TO llC1)
                REDIM                                       lsaFolderPath(1 TO llC1)
                PARSE                                       lsPreProcData, lsaFolderPath(), $CRLF
                llC3                                    =   0
                FOR llC2 = 1 TO llC1
                    IF DIR$(lsObjectRootFolder + "\" + lsaFolderPath(llC2) + "\Moxie.exe") = "Moxie.exe" THEN
                        INCR                                llC3
                        psaFolderPath(%BackupRoot,   llC3) = lsBackupRootFolder
                        psaFolderPath(%FolderRoot,   llC3) = lsObjectRootFolder
                        psaFolderPath(%StatsRecv,    llC3) = psStatsRecvFolder
                        psaFolderPath(%FolderObject, llC3) = lsaFolderPath(llC2)
                        lsFolderPath                    =   psaFolderPath(%FolderRoot, llC3) + "\" + psaFolderPath(%FolderObject, llC3)
                        IF LEN( DIR$(lsFolderPath + "\Moxie.cfg")) THEN
                            sFileGet                        lsFolderPath + "\Moxie.cfg", psaFolderPath(%ConfigData, llC3), llLen
                        END IF
                        IF LEN( psaFolderPath(%ConfigData, llC3)) THEN
                            psaFolderPath(%IP               , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgIP              ), $CRLF))
                            psaFolderPath(%MaxConnections   , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgMaxConnections  ), $CRLF))
                            psaFolderPath(%HttpPort         , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgHttpPort        ), $CRLF))
                            psaFolderPath(%HttpsPort        , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgHttpsPort       ), $CRLF))
                            psaFolderPath(%CertFile         , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgCertFile        ), $CRLF))
                            psaFolderPath(%RelayHttpsHost   , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgRelayHttpsHost  ), $CRLF))
                            psaFolderPath(%Encoding         , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgEncoding        ), $CRLF))
                            psaFolderPath(%RAMRecvSize      , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgRAMRecvSize     ), $CRLF))
                            psaFolderPath(%DLLs             , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgDLLs            ), $CRLF))
                            psaFolderPath(%LocalBKPath      , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgLocalBKPath     ), $CRLF))
                            psaFolderPath(%SendBKName       , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgSendBKName      ), $CRLF))
                            psaFolderPath(%SendBKPort       , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgSendBKPort      ), $CRLF))
                            psaFolderPath(%SendBKPWHash     , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgSendBKPWHash    ), $CRLF))
                            psaFolderPath(%RecvBKPort       , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgRecvBKPort      ), $CRLF))
                            psaFolderPath(%RecvBKPWHash     , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgRecvBKPWHash    ), $CRLF))
                            psaFolderPath(%ServiceName      , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgServiceName     ), $CRLF))
                            psaFolderPath(%ServiceUser      , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgServiceUser     ), $CRLF))
                            psaFolderPath(%DiskFlushTimer   , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgDiskFlushTimer  ), $CRLF))
                            psaFolderPath(%AltIPInfo        , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgAltIPInfo       ), $CRLF))
                            psaFolderPath(%RelayNoAltIP     , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgRelayNoAltIP    ), $CRLF))
                            psaFolderPath(%ForcedCookies    , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgForcedCookies   ), $CRLF))
                            psaFolderPath(%Meta             , llC3) = TRIM$( EXTRACT$( REMAIN$( psaFolderPath(%ConfigData, llC3),$cfgMeta            ), $CRLF))
                            
                            psaFolderPath(%HttpPort, llC3)  = IIF$( VAL(psaFolderPath(%HttpPort,  llC3)) = 0, "", FORMAT$(VAL(psaFolderPath(%HttpPort,  llC3))))
                            psaFolderPath(%HttpsPort, llC3) = IIF$( VAL(psaFolderPath(%HttpsPort, llC3)) = 0, "", FORMAT$(VAL(psaFolderPath(%HttpsPort, llC3))))
                            
                            Replace                         $TAB  with $SEP_TAB  in psaFolderPath(%ConfigData, llC3)
                            Replace                         $CRLF with $SEP_CRLF in psaFolderPath(%ConfigData, llC3)
                            
                        END IF
                    END IF
                NEXT
                REDIM                                       PRESERVE psaFolderPath(1 TO %MAXcfgFIELDS, 1 TO llC3)
            END IF
            
            EXIT                                            SUB
            
        ParseConfigParam:
                lsData                                  =   REMAIN$( lsLookForResult, lsLookFor)
                lsData                                  =   EXTRACT$( lsData, "[")
                llC4                                    =   PARSECOUNT(lsData, $CRLF)
                REDIM                                       lsaData(1 TO llC4)
                PARSE                                       lsData, lsaData(), $CRLF
                llC6                                    =   0
                FOR llC5 = 1 to llC4
                    llFlag                              =   %True
                    If Len( Trim$(lsaData(llC5), ANY $WHITESPACE )) = 0 THEN llFlag = %False
                    If left$( Trim$(lsaData(llC5), ANY $WHITESPACE ), 1) = "#" then llFlag = %False
                    IF llFlag = %False THEN iterate for
                    INCR                                    llC6
                    lsaData(llC6)                       =  Trim$(lsaData(llC5), ANY $WHITESPACE )
                Next
                REDIM Preserve lsaData(1 to llC6)
                If llC6 then
                    lsLookForResult                     =   join$( lsaData(), $CRLF)
                else
                    lsLookForResult                     =   ""
                End If
            RETURN
    END SUB
    
    sub MetaCapture( psaFolderPath() as string, psaMeta() as string)
    	'make the Meta information more suitable for lookup
    	LOCAL lsData, lsaData(), lsaTmp(), lsaTmp2() as string
        LOCAL llC1, llC2, llC3, llC4, llC5 AS LONG
    	
    	llC2 = UBOUND( psaFolderPath(2))
    	
    	'redim psaMeta() to same size as psaFolderPath() and process
    	REDIM psaMeta(1 to llC2)
        REDIM lsaData (1 to llC2)
        For llC1 = 1 to llC2
            lsaData(llC1)                           	=	psaFolderPath(%Meta, llC1)
        Next
        For llC1 = 1 to llC2
            lsData			                           	=	lsaData(llC1)
            llC3                        				=	parsecount( lsData, ";")
            Redim                       				 	lsaTmp( 1 to llC3)
            Parse                       				 	lsData, lsaTmp(), ";"
            Reset                       				 	lsData
            If Len( lsaTmp(1)) THEN
                llC5                                    =   0
                FOR llC4 = 1 to llC3
                    If INSTR( LCASE$( lsaTmp(llC4)), "nightly-") = 0 THEN iterate for
                    INCR                                    llC5
                    lsaTmp(llC5)                      	=	lsaTmp(llC4)
                Next
                llC3									=	llC5
                REDIM Preserve lsaTmp(1 to llC3)
        		REDIM lsaTmp2(1 to llC3, 2)
                FOR llC4 = 1 to llC3
                	'perform a single instance case-insensitive REPLACE "nightly-" WITH "" IN lsaTmp(llC4)
                	lsaTmp(llC4)						=	ReplaceOnce( lsaTmp(llC4), "nightly-", "")
                	'and trim
                	lsaTmp2( llC4, 1)					=	Extract$( lsaTmp(llC4), ":")
                	lsaTmp2( llC4, 2)					=	Remain$( lsaTmp(llC4), ":")
                	lsaTmp2( llC4, 1)					=	trim$( lsaTmp2( llC4, 1), ANY $WHITESPACE)
                    lsaTmp2( llC4, 2)                  	=	trim$( lsaTmp2( llC4, 2), ANY $WHITESPACE)
                    lsaTmp(llC4)						=	lsaTmp2( llC4, 1) & $SEP_SOH & lsaTmp2( llC4, 2)
                Next
                
                psaMeta(llC1)							=	Join$( lsaTmp(), $SEP_NUL)
            End If
        Next
	end sub
    
    FUNCTION ReplaceOnce( psString as string, psSearchFor as string, psReplaceWith as string) as string
        ' PB Thread https://forum.powerbasic.com/forum/user-to-user-discussions/
        ' ... source-code/60412-a-time-efficient-case-insensitive-replace-function
        local llC1, llC2 as long
        llC2                =   LEN(psSearchFor)
        llC1                =   INSTR(LCASE$(psString), LCASE$(psSearchFor))
        If llC1 = 0 then
            FUNCTION = psString
        ELSE
            FUNCTION = LEFT$(psString, llC1 - 1) + psReplaceWith + MID$(psString,llC1 + llC2)
        End If
    End Function
    
    FUNCTION MetaSearch( psaMeta() AS STRING, plFolderPathNum AS LONG, psLookForThisMetaKey AS STRING) AS STRING
    	LOCAL llC1, llC2 as long
        LOCAL lsResult, lsaTmp() as string
        
        llC2                =	parsecount( psaMeta( plFolderPathNum), CHR$(0))
        Redim                   lsaTmp( 1 to llC2)
        Parse                   psaMeta( plFolderPathNum), lsaTmp(), CHR$(0)
        For llC1 = 1 to llC2
            If LCASE$( Extract$( lsaTmp( llC1), CHR$(1))) = LCASE$(psLookForThisMetaKey) THEN
                lsResult = Remain$( lsaTmp( llC1), CHR$(1))
            End If
        Next
        FUNCTION = lsResult
	END FUNCTION         
            
    sub sCaptureConfigurationSave( psWorkFldr as string, psaFolderPath() as string, psResult as string)
        LOCAL lsData as string
        LOCAL llC1, llC2 AS LONG
        
        lsData                                          =   ""
        lsData                                          +=  "FolderRoot"          + $TAB
        lsData                                          +=  "BackupRoot"          + $TAB
        lsData                                          +=  "StatsRecv"           + $TAB
        lsData                                          +=  "FolderObject"        + $TAB
        lsData                                          +=  "ConfigData"          + $TAB
        lsData                                          +=  $cfgIP                + $TAB
        lsData                                          +=  $cfgMaxConnections    + $TAB
        lsData                                          +=  $cfgHttpPort          + $TAB
        lsData                                          +=  $cfgHttpsPort         + $TAB
        lsData                                          +=  $cfgCertFile          + $TAB
        lsData                                          +=  $cfgRelayHttpsHost    + $TAB
        lsData                                          +=  $cfgEncoding          + $TAB
        lsData                                          +=  $cfgRAMRecvSize       + $TAB
        lsData                                          +=  $cfgDLLs              + $TAB
        lsData                                          +=  $cfgLocalBKPath       + $TAB
        lsData                                          +=  $cfgSendBKName        + $TAB
        lsData                                          +=  $cfgSendBKPort        + $TAB
        lsData                                          +=  $cfgSendBKPWHash      + $TAB
        lsData                                          +=  $cfgRecvBKPort        + $TAB
        lsData                                          +=  $cfgRecvBKPWHash      + $TAB
        lsData                                          +=  $cfgServiceName       + $TAB
        lsData                                          +=  $cfgServiceUser       + $TAB
        lsData                                          +=  $cfgDiskFlushTimer    + $TAB
        lsData                                          +=  $cfgAltIPInfo         + $TAB
        lsData                                          +=  $cfgRelayNoAltIP      + $TAB
        lsData                                          +=  $cfgForcedCookies     + $TAB
        lsData                                          +=  $cfgMeta             
        lsData                                          +=  $CRLF
        
        replace                                             " =" with "" in lsData
        
        FOR llC2 = 1 TO UBOUND( psaFolderPath(2))
            For llC1 = 1 to UBOUND( psaFolderPath(1))
                lsData                                  +=  psaFolderPath(llC1, llC2)   + $TAB
            Next
            lsData                                      +=  $CRLF
        NEXT
        psResult                                        +=  $CRLF + Trim$(lsData, $CRLF)
        sFilePut                                            psWorkFldr + $ProgramName + ".conf.dump", Trim$(lsData, $CRLF)
        sFilePut                                            psWorkFldr + "Moxie\Recv\conf.dump", Trim$(lsData, $CRLF)
    End Sub
    
    SUB CommitLog( psWorkFldr AS STRING, psResultLog AS STRING)
        sFilePut                                            psWorkFldr + $ProgramName + "\" + $ProgramName + "." + StampItDateHM + ".LogFile.log", TRIM$( psResultLog, $CRLF)
    END SUB
    
    SUB sFileGet( psCompletePath AS STRING, psData AS STRING, plLOF AS LONG)
        LOCAL llFileNum AS LONG
        llFileNum                                       =   FREEFILE
        psData                                          =   ""
        OPEN                                                psCompletePath FOR BINARY LOCK SHARED AS llFileNum
            plLOF                                       =   LOF(llFileNum)
            GET$                                            llFileNum, LOF(llFileNum), psData
        CLOSE                                               llFileNum
    END SUB
    
    SUB sFilePut( psCompletePath AS STRING, psData AS STRING)
        LOCAL llFileNum AS LONG
        llFileNum                                       =   FREEFILE
        OPEN                                                psCompletePath FOR BINARY LOCK SHARED AS llFileNum
            PUT$                                            llFileNum, psData : SETEOF(llFileNum)
        CLOSE                                               llFileNum
    END SUB
    
    SUB sFilePutSeq( psCompletePath AS STRING, plMode as long, psData AS STRING)
        LOCAL llFileNum AS LONG
        llFileNum                                       =   FREEFILE
        OPEN                                                psCompletePath FOR BINARY LOCK write AS llFileNum
            If %file_Replace = plMode THEN                  seek llFileNum, 0
            If %file_Append  = plMode THEN                  seek llFileNum, lof(llFileNum)
            PUT$                                            llFileNum, psData : SETEOF(llFileNum)
        CLOSE                                               llFileNum
    END SUB
    
    SUB sEnsureFolder( psWorkFldr AS STRING, psCompletePath AS STRING, psShellCommandResult AS STRING)
        LOCAL lsCommand AS STRING
        lsCommand                                       =   "IF NOT EXIST " + $DQ + TRIM$(psCompletePath) + $DQ + " (MKDIR " + $DQ + TRIM$(psCompletePath) + $DQ + ")"
        ShellExec                                           psWorkFldr, "", lsCommand, psShellCommandResult
    END SUB
    
    SUB StampItInit
        GLOBAL gsDate, gsTime AS STRING
        gsDate                                          =   DATE$
        gsTime                                          =   TIME$
    END SUB
    
    FUNCTION StampItDate AS STRING
        GLOBAL gsDate, gsTime AS STRING
        FUNCTION                                        =   RIGHT$(gsDate, 4) + "-" + LEFT$(gsDate, 5)
    END FUNCTION
    
    FUNCTION StampItNowLogFmt AS STRING
        local lsDate, lsTime AS STRING
        lsDate                                          =   DATE$
        lsTime                                          =   TIME$
        FUNCTION                                        =   RIGHT$(lsDate, 4) + "-" + LEFT$(lsDate, 5) + " " + lsTime
    END FUNCTION
    
    FUNCTION StampItDateHM AS STRING
        GLOBAL gsDate, gsTime AS STRING
        FUNCTION                                        =   RIGHT$(gsDate, 4) + "-" + LEFT$(gsDate, 5) + "-" + LEFT$(REMOVE$(gsTime, ":"),4)
    END FUNCTION
    
    FUNCTION StampItCurrentSeconds AS STRING
        LOCAL lsDate, lsTime AS STRING
        lsDate                                          =   DATE$
        lsTime                                          =   TIME$
        FUNCTION                                        =   RIGHT$(lsDate, 4) + "-" + LEFT$(lsDate, 5) + "-" + REMOVE$(lsTime, ":")
    END FUNCTION
    
    FUNCTION GetDow( psDate AS STRING) AS STRING
        'Clay Clear, Member PB Forums
        'posted September 29, 2005 03:49 AM
        
        LOCAL x AS SYSTEMTIME, q AS QUAD
        
        x.wyear                                         =   VAL(PARSE$(psDate, "-", 1))
        x.wmonth                                        =   VAL(PARSE$(psDate, "-", 2))
        x.wday                                          =   VAL(PARSE$(psDate, "-", 3))
        
        systemtimetofiletime                                x, BYVAL VARPTR(q)
        filetimetosystemtime                                BYVAL VARPTR(q), x
        
        FUNCTION                                        =   READ$((x.wdayofweek)+1)
        
        DATA                                                "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
        
    END FUNCTION
    
    Function QuadToStatTime (pqDateTime as quad) as string
        local lqTmp as quad
        local llDay, llH, llM, llS as long
        
        lqTmp                                           =   pqDateTime
        llDay                                           =   lqTmp \ 86400   :   lqTmp   =   lqTmp - (llDay * 86400)
        llH                                             =   lqTmp \ 3600    :   lqTmp   =   lqTmp - (llH * 3600)
        llM                                             =   lqTmp \ 60      :   lqTmp   =   lqTmp - (llM * 60)
        llS                                             =   lqTmp
        
        function                                        =   format$( llDay) + " " + Format$( llH, "00") + ":" + Format$( llM, "00") + ":" + Format$( llS, "00")
    End Function
    
    Function DateTimeToQuad (psDateTime as string) as QuaD
        'expected format
        ' 0        1         2
        ' 12345678901234567890
        ' 2014-02-29 15:34:25
        local llYmd, llH, llM, llS as long
        local lsYmd, lsHms as string
        
        lsYmd                                           =   Extract$( psDateTime, " ")
        lsHms                                           =   Remain$(  psDateTime, " ")
        
        llYmd                                           =   String2Julian( lsYmd)
        llH                                             =   VAL(LEFT$(    lsHms, 2))
        llM                                             =   VAL(MID$(     lsHms, 4, 2))
        llS                                             =   VAL(RIGHT$(   lsHms, 2))
        
        function                                        =   llS + (llM * 60) + (llH * 3600) + (llYmd * 86400)
    End Function
    
    FUNCTION Julian2String( plJulianDate AS LONG) AS STRING
        'Ref: Fliegel and van Flandern (1968)
        'From http://www.hermetic.ch/cal_stud/jdn.htm#comp
        LOCAL D, I, J, L, M, N, Y AS LONG
        
        l                                               =   plJulianDate + 68569
        n                                               =   ( 4 * l ) \ 146097
        l                                               =   l - ( 146097 * n + 3 ) \ 4
        i                                               =   ( 4000 * ( l + 1 ) ) \ 1461001
        l                                               =   l - ( 1461 * i ) \ 4 + 31
        j                                               =   ( 80 * l ) \ 2447
        d                                               =   l - ( 2447 * j ) \ 80
        l                                               =   j \ 11
        m                                               =   j + 2 - ( 12 * l )
        y                                               =   100 * ( n - 49 ) + i + l
        
        FUNCTION                                        =   FORMAT$(Y, "0000") + "-" + FORMAT$(M, "00") + "-" + FORMAT$(D, "00")
    END FUNCTION
    
    FUNCTION String2Julian( psDate AS STRING) AS LONG
        'Ref: Fliegel and van Flandern (1968)
        'From http://www.hermetic.ch/cal_stud/jdn.htm#comp
        LOCAL Y, M, D AS LONG
        
        IF IsDateValid(psDate) = %False THEN
            FUNCTION                                    =   0
            EXIT                                            FUNCTION
        END IF
        
        Y                                               =   VAL(LEFT$(  psDate, 4))
        M                                               =   VAL(MID$(   psDate, 6, 2))
        D                                               =   VAL(RIGHT$( psDate, 2))
        FUNCTION                                        =   ( 1461 * ( y + 4800 + ( m - 14 ) \ 12 ) ) \ 4 + _
                                                            ( 367 * ( m - 2 - 12 * ( ( m - 14 ) \ 12 ) ) ) \ 12 - _
                                                            ( 3 * ( ( y + 4900 + ( m - 14 ) \ 12 ) \ 100 ) ) \ 4 + _
                                                              d - 32075
    END FUNCTION
    
    FUNCTION IsDateValid( psDate AS STRING) AS LONG
        'Adapted From http://www.hermetic.ch/cfunlib/dateval.htm
        LOCAL llYear, llMonth, llDay AS LONG
        
        llYear                                          =   VAL(LEFT$(   psDate, 4))
        llMonth                                         =   VAL(MID$(    psDate, 6, 2))
        llDay                                           =   VAL(RIGHT$(  psDate, 2))
        
        FUNCTION                                        =   %True
        IF llDay < 1 OR llYear < 1800 OR llYear > 2199 THEN
            FUNCTION                                    =   %False
        ELSE
            SELECT CASE AS LONG llMonth
                CASE 1  :       IF llDay > 31 THEN FUNCTION = %False
                CASE 2  :   IF IsLeapYear( llYear) THEN
                                IF llDay > 29 THEN FUNCTION = %False
                            ELSE
                                IF llDay > 28 THEN FUNCTION = %False
                            END IF
                CASE 3  :       IF llDay > 31 THEN FUNCTION = %False
                CASE 4  :       IF llDay > 30 THEN FUNCTION = %False
                CASE 5  :       IF llDay > 31 THEN FUNCTION = %False
                CASE 6  :       IF llDay > 30 THEN FUNCTION = %False
                CASE 7  :       IF llDay > 31 THEN FUNCTION = %False
                CASE 8  :       IF llDay > 31 THEN FUNCTION = %False
                CASE 9  :       IF llDay > 30 THEN FUNCTION = %False
                CASE 10 :       IF llDay > 31 THEN FUNCTION = %False
                CASE 11 :       IF llDay > 30 THEN FUNCTION = %False
                CASE 12 :       IF llDay > 31 THEN FUNCTION = %False
                CASE ELSE
                    FUNCTION                            =   %False
            END SELECT
        END IF
    END FUNCTION
    
    FUNCTION IsLeapYear( plYear AS LONG) AS LONG
        'Adapted From http://www.hermetic.ch/cfunlib/dateval.htm
        IF ( (plYear MOD 4) <> 0 ) THEN
            FUNCTION = %False
        ELSEIF ( (plYear MOD 400) = 0 ) THEN
            FUNCTION = %True
        ELSEIF ( (plYear MOD 100) = 0 ) THEN
            FUNCTION = %False
        ELSE
            FUNCTION = %True
        END IF
    END FUNCTION
    